#ifndef _FS_ADVHISCORESWINDOW_H
#define _FS_ADVHISCORESWINDOW_H

#include "freesweeper.h"
#include "counterswindow.h"
#include "translation.h"

class adv_hiscores_window : public QDialog
{
	Q_OBJECT
	
	translation* T;

	counters_window* ctrs;

	QString date_template;
	
	QGridLayout* layout;
	QTabWidget t;
	QGroupBox g_page_global;
	QVBoxLayout* l_global;
	QGroupBox g_page_f;
	QVBoxLayout* l_f;
	QGroupBox g_page_nf;
	QVBoxLayout* l_nf;

	QPushButton reset;
	QPushButton load;
	QPushButton ok;

	void new_record_group(const QString& name,double* src,int pr,QString* n_src,QDateTime* d_src,
		record_state* has_src,QLayout* where);
	void add_record(const QString& name, record* r,int pr);
	void refresh();
public:
	int max_records;

	adv_hiscores_window(translation* T,skin* sk,counters_window* ctrs,QString date_template,int max_records);
	~adv_hiscores_window();
private slots:
	void quit();
	void reseths();
	void loadhs();
signals:
	void reset_hiscores();
	void load_hiscores();
};

#endif

