#ifndef _FS_AUTOSAVE_EDITOR_H
#define _FS_AUTOSAVE_EDITOR_H

#include "freesweeper.h"
#include "autosavecondition.h"
#include "parser.h"
#include "formulaeditor.h"
#include "translation.h"

class autosave_editor : public QDialog
{
	Q_OBJECT
	
	translation* T;
	skin* sk;
	QList<autosave_condition*>& conditions;
	parser* p;
	
	QGridLayout* layout;
	QTableWidget t;
	QLabel l_name;
	QLineEdit name;
	QLabel l_formula;
	QLineEdit e_formula;
	QLabel l_filename;
	QLineEdit filename;
	QPushButton applyfile;
	QLabel l_folder;
	QLineEdit folder;
	QLabel l_popup;
	QLineEdit popup;
	QPushButton applypopup;
	QCheckBox on;
	QCheckBox rawvf;
	QCheckBox terminal;
	QCheckBox c_popup;
	QPushButton addcond;
	QPushButton delcond;
	QPushButton editformula;
	QPushButton browsefolder;
	QPushButton apply;
	QPushButton ok;

	int id,row;	// current condition and row
	bool& changed;
	
	void init();
public:
	autosave_editor(translation* T,skin* sk,QList<autosave_condition*>& conds,parser* p,bool& changed);

	void enable(bool on);
	void refresh();
	int row_to_id(int row);
	QString retrieve_folder();
public slots:
	void quit();

	void choose(int row,int column,int prev_row,int prev_column);

	void add();
	void remove();

	void apply_formula();
	void f_editor();
	
	void change_name(const QString& n);
	void change_folder(const QString& n);
	void apply_file();
	void apply_popup();
	
	void toggle();
	void toggle_popup();
	void toggle_terminal();
	void toggle_rawvf();
	
	void edit_folder();
};


#endif

