#ifndef _FS_BOARD_DATA_H
#define _FS_BOARD_DATA_H

#include "freesweeper.h"

struct board_data
{
	boardstate state;

	int width,height,n_mines;
	int n_boards;
	
	levelname level;

	// board properties
	int openings;
	int islands;
	int bbbv;
	double obv;
	int zini,hzini;
	int numbers[9];	// number[0] = the number of numbers
	int mines_in_corners,mines_on_walls;	// mines in corners & mines on walls (including corners)
	QList<int> size_op,size_isl;	// the sizes of openings and islands
	
	// counters
	int open_squares,open_mines;
	int solved_ops;
	int solved_isls;
	int solved_bbbv;
	int l_clicks,r_clicks,d_clicks,clicks_15;
	int rilian_clicks;
	int wasted_l_clicks,wasted_r_clicks,wasted_d_clicks,wasted_clicks_15;
	int unflags,misflags,misunflags,wasted_flags;
	int distance;
	int shown_numbers[9];	// shown_numbers[0] = the number of shown numbers
	int opened_sq;	// opened squares
	int flags,right_flags;
	
	// solvers' data
	int known_mines;
	
	board_data();
	void reset();
};

#endif

