#include "display.h"

display::display(skin* s):state(-1),tenth_state(0),active(true),has_tenth(false),sk(s)
{
	int dw=s->display_width;
	int dh=s->display_height;
	int sdw=s->small_display_width;
	lbl[0].setGeometry(1,1,dw,dh);
	lbl[1].setGeometry(1+dw,1,dw,dh);
	lbl[2].setGeometry(1+2*dw,1,dw,dh);
	lbl[3].setGeometry(1+3*dw,1,sdw,dh);
	for(int i=0;i<4;++i) lbl[i].setParent(this);
}

void display::show(int num)
{
	if(state==num) return;
	state=num;
	show();
}

void display::show()
{
	if(!active) return;
	int num=state;
	if(num>999) num=999;
	if(num<-99) num=-99;
	if(num<0)
	{
		num=-num;
		lbl[0].setPixmap(sk->display_minus);
	}
	else
		lbl[0].setPixmap(sk->display[num/100]);
	lbl[1].setPixmap(sk->display[num%100/10]);
	lbl[2].setPixmap(sk->display[num%10]);
	update();
}

void display::correct_tenth(int& tenth)
{
	if(tenth<0 || tenth>9) tenth=0;
}

void display::switch_tenth(bool enabled)
{
	has_tenth=enabled;
	lbl[3].setVisible(has_tenth);
}

void display::show_tenth(int tenth)
{
	tenth_state=tenth;
	if(!active) return;
	lbl[3].setPixmap(sk->smalldisplay[tenth]);
}

void display::show_time(int time)
{
	if(has_tenth)
	{
		int curtenth=time ? 1+(time)/100 : 0;
		show(curtenth/10);
		show_tenth(curtenth%10);
	}
	else
	{
		int cursecond=time ? 1+(time)/1000 : 0;
		show(cursecond);
	}
}

void display::decrement()
{
	--state;
	show();
}

void display::increment()
{
	++state;
	show();
}

void display::switch_display(bool enabled)
{
	active=enabled;
	if(!active)
	{
		for(int i=0;i<3;++i) lbl[i].setPixmap(sk->display_off);
		lbl[3].setPixmap(sk->smalldisplay_off);
	}
	else 
	{
		show();
		correct_tenth(tenth_state);
		show_tenth(tenth_state);
	}
}

void display::mouseDoubleClickEvent(QMouseEvent*)
{
	emit double_click();
}

void display::paintEvent(QPaintEvent*)
{
	// draw frame
	int w=width()-1,h=height()-1;
	painter.begin(this);
	painter.setPen(sk->display_frame1);
	painter.drawLine(0,0,0,h);
	painter.drawLine(0,0,w,0);
	painter.setPen(sk->display_frame2);
	painter.drawLine(w,h,w,1);
	painter.drawLine(w,h,1,h);
	painter.end();
}

