#ifndef _FS_FORMULA_EDITOR_H
#define _FS_FORMULA_EDITOR_H

#include "freesweeper.h"
#include "parser.h"
#include "evaluable.h"
#include "translation.h"

enum formula_editor_type
{
	fet_counter_formula=0,
	fet_expression=1
};

class formula_editor : public QDialog
{
	Q_OBJECT
	QLineEdit f;
	QPushButton* button;
	QPushButton b_ok, b_cancel;
	QSignalMapper mapper;
	QVBoxLayout* l_main;
	QGridLayout *l_1,*l_3,*l_4;
	formula_editor_type type;
	
	translation* T;
	parser* p;
public:
	formula_editor(formula_editor_type type,translation* T,skin* sk,parser* p);

	c_formula* resc;
	formula* rese;

	void get_formula(const QString& before);
	void get_formula(c_formula* before=0);
	void get_expression(formula* before=0);
public slots:
	void add(const QString& s);
	void ok();
	void cancel();
	void brackets();
	void sq_brackets();
};

#endif

