#ifndef _FS_HISTORY_H
#define _FS_HISTORY_H

#include "freesweeper.h"
#include "parser.h"
#include "eval.h"
#include "rank.h"
#include "board-data.h"

const QString F_history="freesweeper.history";

class history
{
	translation* T;

	parser* Parser;
	evaluator* Eval;
	
	QFile f;
	
	QList<rank*> ranks;
	
	bool ranks_changed;
public:
	int total_games[n_levels+1];
	int num_ranks;
	double dens_threshold;
	
	int id_named[n_named_ranks];
	
	history(translation* T,parser* p,evaluator *ev);
	~history();
	
	void touch_dens();
	
	void add(board_data* brd,gamemode mode,int time);
	void add_dens(board_data* brd,int time,bool finished);
	
	int get_rank(int id);
	int get_named_rank(int name);
	
	void read_game(board_data* brd,gamemode* mode,evaluator* Eval,QFile& f);
	
	void save_ranks();
};


#endif

