#ifndef _FS_IRCMODULE_H
#define _FS_IRCMODULE_H

#include "freesweeper.h"
#include "parser.h"
#include "evaluable.h"
#include "eval.h"
#include "translation.h"

const int n_irc_strings=9;

enum irc_id
{
	ii_finished=0,
	ii_finished_dens=1,
	ii_finished_cheat=2,
	ii_finished_video=3,
	
	ii_blasted=4,
	ii_blasted_dens=5,
	ii_blasted_cheat=6,
	ii_blasted_video=7,
	
	ii_marathon=8
};

class ircmodule : public QObject
{
	Q_OBJECT

	translation* T;

	parser* Parser;
	evaluator* Eval;
	
	evaluable_string* strings[n_irc_strings];
	
	bool strings_changed;
public:
	ircmodule(translation* T,parser* p, evaluator* ev);
	~ircmodule();
	
	void load();
	void save();
public slots:
	void copy_string(int id);
	void copy_string(int id,QString player);
	void edit_string(int id);
};

#endif

