#include "labelid.h"

labelid::labelid(translation* T,skin* sk):T(T),sk(sk)
{
}

void labelid::set_text(const QString& s)
{
	text=s;
	repaint();
}

void labelid::paintEvent(QPaintEvent*)
{
	int off=sk->label_text_offset;
	int off2=2*off;
	
	QPainter p(this);
	p.fillRect(rect(),QBrush(sk->label_background));
	p.setPen(sk->label_font);
	if(text!="")
		p.drawText(QRect(0,off,width(),height()-off2),Qt::AlignHCenter | Qt::AlignVCenter,text);
	else
		p.drawText(QRect(0,off,width(),height()-off2),Qt::AlignHCenter | Qt::AlignVCenter,
			T->str[ins_empty_name_label]);
}

void labelid::get_name()
{
	QString s=input(this,T->str[ins_name_query],text);
	if(s!="")
	{
		set_text(s);
		emit change_player(s);
	}
}

void labelid::mouseDoubleClickEvent(QMouseEvent*)
{
	if(enable_changes) get_name();
}

