#ifndef _FS_RANKTREE_H
#define _FS_RANKTREE_H

#include "freesweeper.h"

struct rank_tree_node
{
	double value;
	
	bool red;
	int size;
	
	rank_tree_node* p;	// parent
	rank_tree_node* l;
	rank_tree_node* r;	// left & right children
	
	rank_tree_node(double v);
	rank_tree_node(double v,rank_tree_node *p);
	~rank_tree_node();
	
	QString print();
};

class rank_tree
{
	rank_tree_node* root;
	
	rank_tree_node* insert(double v, int& rank, bool lower_is_better);
	void left_rotate(rank_tree_node* t);
	void right_rotate(rank_tree_node* t);
public:
		
	rank_tree();
	~rank_tree();
	
	int insert(double value,bool lower_is_better);	// returns the rank of the inserted value
	
	QString print();
};

#endif

