#ifndef _FS_SKIN_H
#define _FS_SKIN_H

#include "freesweeper.h"
#include "settings.h"
#include "translation.h"

class skin
{
public:
	bool loaded;
	
	double coeff;

	int square_size;
	static const int standard_square_size=16;
	int head_size;
	int topborder_size;
	
	int display_width;
	int small_display_width;
	int display_height;
	int smiley_width;
	int smiley_height;
	int smiley_v_offset;
	
	int label_h_offset;
	int label_v_offset;
	int label_height;
	int label_text_offset;
	
	int crit_width,crit_width_2;
	int max_width;
	int max_height;
	
	QColor background;
	QColor label_background;
	QColor label_font;
	QColor display_frame1,display_frame2;
		
	int rm_h_offset;
	int rt_h_offset;
	
	int smiley_h_o_offset;
	
	QColor arrow,arrow_border;
	double arrow_opacity;
	QColor mouse_path[4];
	QColor opening_border;
	int mouse_path_rect_size;
	int opening_border_thickness;
	
	int counter_width;
	int counter_height;
	int counter_font_size;
	QFont counter_font;
	QColor counter_name_back;
	QColor counter_value_back;

	double chartEWidth;
	int chartLength,chartHeight;
	int chartLabelVOffset[2];
	int chartLabelHOffset[2];
	int chartLineThickness,chartLineThicknessSpec;
	QColor chartBackground,chartSecondFrame,chartSecondLabel;
	int chartSecondLabelVOffset;
	QColor chartLeft,chartRight,chartMiddle,chartOpening,chartIsland;
	int chartLeftH,chartRightH,chartMiddleH,chartOpeningH,chartIslandH;
	
	QString skin_path;
	QString name;
	
	QPixmap sq;
	QPixmap sq_pr;
	QPixmap sq_empty;
	QPixmap question;
	QPixmap question_pr;
	QPixmap number[10];
	QPixmap numberpop[10];
	QPixmap display[10];
	QPixmap smalldisplay[10];
	QPixmap display_minus;
	QPixmap display_off;
	QPixmap smalldisplay_off;
	QPixmap border[10];
	QPixmap blasted_mine;
	QPixmap mine;
	QPixmap minepop;
	QPixmap flag;
	QPixmap flag_false;
	QPixmap flag_wasted;
	QPixmap lborder;
	QPixmap rborder;
	QPixmap tborder;
	QPixmap smiley[n_modes];
	QPixmap smiley_click[n_modes];
	QPixmap smiley_stress[n_modes];
	QPixmap smiley_win[n_modes];
	QPixmap smiley_fail[n_modes];
	
	QIcon b_play;
	QIcon b_pause;
	QIcon b_stop;
	
	QIcon program_icon;
	
	translation* T;
	
	skin(translation* T);
	
	void load(const QString& desc);
	
	void load_raw(const QString& file);
	void write_raw(const QString& file);
	
	void load_from_ds(QDataStream& d);
	
	void load_default();
};

#endif

