#include "smiley.h"

smiley::smiley(skin* sk,gamemode mode):sk(sk),mode(mode)
{
	pp=p=&(sk->smiley[mode]);
	repaint();
	allowed_set_mode=true;
}

void smiley::stress()
{
	pp=p=&(sk->smiley_stress[mode]);
	repaint();
}

void smiley::unstress()
{
	pp=p=&(sk->smiley[mode]);
	repaint();
}

void smiley::changed_state(boardstate state)
{
	cout<<"smiley state "<<state<<endl;
	switch(state)
	{
	case win:
		pp=p=&(sk->smiley_win[mode]);
		break;
	case fail:
		pp=p=&(sk->smiley_fail[mode]);
		break;
	case playing:case before_game:case playing_video:
		pp=p=&(sk->smiley[mode]);
		break;
	default:
		break;
	}
	repaint();
}

void smiley::force_new_game()
{
	emit new_game();
}
void smiley::set_mode(int m)
{
	if(!allowed_set_mode) return;
	if(m<0 || m>=n_enabled_modes) m=0;
	emit changed_mode(mode=(gamemode)m);
	emit new_game();
	p=&(sk->smiley[mode]);
	repaint();
}
void smiley::set_mode_without_restart(int m)
{
	if(m<0 || m>=n_enabled_modes) m=0;
	emit changed_mode(mode=(gamemode)m);
	p=&(sk->smiley[mode]);
	repaint();
}

void smiley::paintEvent(QPaintEvent*)
{
	painter.begin(this);
	painter.drawPixmap(0,0,*p,0,0,sk->smiley_width,sk->smiley_height);
	painter.end();
}

void smiley::press(Qt::MouseButton b)
{
	if(b==Qt::LeftButton)
	{
		left=true;
		ins=true;
		pp=p;
		p=&(sk->smiley_click[mode]);
		repaint();
	}
	else if(b==Qt::RightButton)
	{
		left=false;
		set_mode((gamemode)((mode+1)%n_enabled_modes));
	}
}
void smiley::release(Qt::MouseButton b)
{
	if(b==Qt::LeftButton && left && ins)
	{
		left=false;
		emit new_game();
		p=&(sk->smiley[mode]);
		repaint();
	}
}
void smiley::cancel()
{
	if(!left) return;
	ins=false;
	p=pp;
	repaint();
}
void smiley::mouse_return()
{
	if(!left || ins) return;
	ins=true;
	p=&(sk->smiley_click[mode]);
	repaint();
}

void smiley::mousePressEvent(QMouseEvent* e)
{
	press(e->button());
}

void smiley::mouseReleaseEvent(QMouseEvent* e)
{
	release(e->button());
}

bool smiley::inside(QMouseEvent* e)
{
	return (e->x()>=0 && e->x()<sk->smiley_width && e->y()>=0 && e->y()<sk->smiley_height);
}

void smiley::mouseMoveEvent(QMouseEvent* e)
{
	if(!inside(e))
		cancel();
	else
		mouse_return();
}

bool smiley::is_legal_mode()
{
	return mode==classic || mode==lucky;
}


