#include "freesweeper.h"

struct square
{
	QPixmap* d;	// drawn pixmap
	QPixmap* p;	// current pixmap
	QPixmap* pp;	// pixmap saved after pushing

	int mine;
	int type;	// 0 - active square, >0 - border
	int num;	// number
	int flagged;

	bool questioned;
	bool opened;
	bool wasted_flag;

	int opening;	// 0 - inside island, >0 - number of opening
					// an opening border may belong to two openings,
					// then opening=max(op1,op2)
	int opening2;
	int opborder;	// used to display openings while playing videos
	
	int island;
	
	// ZiNi
	int premium;	// it is also used for storing the number of flag event in board::make_event_list()
	bool zn_opened;
	
	// probabilities fields & methods
	int border;
	double probability;
	int pmine;	// 1 - mine, 0 - unsolved, -1 - safe
	bool psolved;
	bool unknown();
	bool unsolved();
	QMap<int,int> pr;	//n(mines on border) -> n(solutions with mine in this square);

	void reset();
	void new_game();	
	void restart();
	void erase_board_info();	// clear mines and numbers
	
	bool openable();	// may be opened atm
	bool flaggable();	// may contain a flag
	bool unopenable();	// can't be opened without losing the game
	bool unknownsafe();	// safe & closed
	bool unknownmine();
};

