#ifndef _FS_TIMER_H
#define _FS_TIMER_H

#include "freesweeper.h"

class timer : public QObject
{
	Q_OBJECT

	int last_stop;
	int add;
	
	double coeff;

	QTime time;	// this is used to get elapsed time
	QTimer t;	// this is used to generate ticks
public:
	timer();
	
	void start(int coeff=100);
	void pause();
	void resume();
	void stop();
	void stop(int end_time);
	void restart();

	int get_time();
	int get_time_since_stop();

	double get_coeff();
	bool paused();
signals:
	void tick(int time);
	void tick_since_stop(int time_since_stop);
public slots:
	int send_signal();
	void set_time(int time);
	void set_coeff(int coeff);
};

#endif

