#include "translation.h"
#include "settings.h"

const QString interface_string[n_interface_strings]={"Beginner","Intermediate","Expert","24x30","Custom",
"Time trial","Custom marathon",
"Overall","Flagging","Non-flagging",
"Reset","Load from history",
"Are you sure?",
"OK","Cancel",
"Enter number of mines:",
"&Game","&Options","&IRC","&About",
"New","Restart","Restart from blast",
"Marathons","New marathon",
"Preview video","Load video...","Save video...","Load board...","Save board...",
"Show hi-scores...","Show advanced hi-scores...","Show history...","Exit",
"Classic mode","Lucky mode","Density mode","UPK mode","Cheat mode","Edit mode",
"Game options...","Edit counters...","Autosave and popup conditions...","Select skin...","Edit custom marathon...",
"Last game info (finished)","Last game info (blasted)","Marathon info","Records","Averages","AR",
"Today beg","Today int","Today exp","Edit templates","Edit finished game template","Edit blasted game template",
"Edit density template","Edit blasted density template","Edit cheat template","Edit blasted cheat template",
"Edit viewed game template","Edit blasted viewed game template","Edit marathon template",
"Autocopy finished game","Autocopy blasted game","About FreeSweeper...","About Qt...",
"You have new","high score!","high scores","Type in your name:","Congratulations!","Video is corrupt:",
"Video has corrupt board descriptions","Video is empty","There's no board!","Anonymous",
"Label","Condition","File name","Folder","Browse...","Popup message","Apply","Add","Remove","Open formula editor",
"Autosave","Popup","Save as RawVF","Don't check conditions below if this condition is met","Choose folder",
"Enter condition name:","Enter file name:","does not exist",
"Can't open the autosave description file!","Can't open file!","RawVF is corrupt!",
"RawVF contains a marathon, couldn't read a board from it","Invalid mine position","I don't know such board format!",
"MBF does not allow large boards. Try to save as RawVF instead.","no board","wrong number of mines",
"Too many iterations","couldn't open video file","invalid event","Can't open counters file!","Can't open records file!",
"Iteration","Counters","Benchmarks","Speed","Quality","Efficiency","Click rate","Flags",
"Board properties","Ranks","Custom indices","Add counter...","Custom counters manager","Locked","Enter index name:",
"Formula","Decimal places","Better score is","Records","Lower","Higher","Precision","Up","Down",
"Width","Height","Mines",
"Formula editor",
"Time","Estimate",
"3BV","Solved 3BV","3BV/s",
"ZiNi","ZiNi/s",
"HZiNi","HZiNi/s",
"Openings","Hit openings",
"Islands","Cleared islands",
"Clicks","Clicks/s","Wasted clicks",
"Left clicks","Left clicks/s","Wasted left clicks",
"Right clicks","Right clicks/s","Wasted right clicks",
"Double clicks","Double clicks/s","Wasted double clicks",
"1.5 clicks","1.5 clicks/s","Wasted 1.5 clicks",
"RQP","IOS",
"IOE","Throughput","Correctness",
"Mines on wall","Mines in corners",
"Level","Mode",
"Opened squares",
"Ones","Twos","Threes","Fours","Fives","Sixes","Sevens","Eights","Numbers",
"ShownOnes","ShownTwos","ShownThrees","ShownFours",
"ShownFives","ShownSixes","ShownSevens","ShownEights","ShownNumbers","and","or",
"High scores",
"Can't open density history!","Can't create the history file","Can't open ranks file!","Can't access history!",
"Can't open IRC templates file!",
"finished game", "finished density game","finished cheat game","viewed video",
"blasted game","blasted density game","blasted cheat game","viewed blast",
"marathon","Enter template for","Type in your name:","Your name here. Double click to enter",
"Classic mode options","Tenth on red timer","Reveal squares after end","Flag mines after win",
"Set mine counter at 0 after win",
"'?' marks","Treat clicks above board as smiley clicks","Clear board on fail if less than","percents completed",
"Hide timer until end","Force NF","Always at top","Mark wasted flags","Don't show","Hide stats until end",
"Show stats","Inside main window","Separated","Wheel behaviour","New game","Chord","Restart by time limit: ",
"Beep when time exceeds: ","Lucky mode options","Luck by library","Luck by solver","Density mode options",
"Custom width","Custom height","Custom mines","Cheat mode options","Restrict 3BV","Minimum 3BV","Maximum 3BV",
"Restrict ZiNi","Minimum ZiNi","Maximum ZiNi","Restrict HZiNi","Minimum HZiNi","Maximum HZiNi",
"7 on board","8 on board","Number of boards generated","Continues","None","Several","Infinite",
"Show board","Show probabilities","Auto flag","Lawn-mower","Elmar's technique","Nono mouse","SuperClick","SuperFlag",
"unexpected end","identifier or number expected","bracket disbalance"," ( expected after function name",
"garbage at the end of expression","Expression contains a mistake","it was noticed while observing symbol #",
"Formula contains a mistake","String contains a mistake","a second argument of OR expected",
"a second argument of AND expected","square bracket disbalance","a comparison sign expected",
"a second argument of + expected","a second argument of - expected", "a second argument of * expected",
"a second argument of / expected","a second argument of ^ expected","unknown identifier",
"Counter formula contains a mistake","will be reset to the default video folder.",
"Autosave condition contains a mistake","Mouse path","Reveal squares","Event","Video control",
"Blast","Wasted click",	"Guessed click","Misflag","Wasted flag","Guessed flag","Unflag","Misunflag","Wasted chord",
"Wasted chord (1.5)","Hesitation","Rilian click","Question","Skin not found","Autosave editor","Counters editor",
"Custom marathon editor",
"the last interface string"};

const QString E_open_translation="Couldn't open translation file!";

void translation::load(const QString& filename)
{
	path=filename;
	if(filename!="" && QFile::exists(filename))
	{
		settings s(filename);
		if(!s.read(E_open_translation)) path="";
		for(int i=0;i<n_interface_strings;++i) str[i]=s.get(interface_string[i]);
	}
	for(int i=0;i<n_interface_strings;++i) if(str[i]=="") str[i]=interface_string[i];
}

void translation::save(const QString& filename)
{
	settings s(filename);
	for(int i=0;i<n_interface_strings;++i) s.set(interface_string[i],str[i]);
	s.write(E_open_translation);
}


