#include "evaluable.h"


formula::formula():op1(0),op2(0){}
formula::formula(formula* f):op1(f),op2(0){}
formula::~formula()
{
	if(op1) delete op1;
	if(op2) delete op2;
}
QString formula::print()
{
	const char signs[]={'+','-','*','/'};
	const char rels[]={'<','>','='};
	if(id==f_plus || id==f_minus)
	{
		QString s1=op1->print(),s2=op2->print();
		if(id==f_minus && (op2->id==f_plus || op2->id==f_minus)) s2='('+s2+')';
		return s1+signs[id-f_plus]+s2;
	}
	else if(id==f_times || id==f_div)
	{
		QString s1=op1->print(),s2=op2->print();
		if(op1->id==f_plus || op1->id==f_minus) s1='('+s1+')';
		if(op2->id==f_plus || op2->id==f_minus || ((op2->id==f_times || op2->id==f_div) && op2->id==f_div)) 
			s2='('+s2+')';
		return s1+signs[id-f_plus]+s2;
	}
	else if(id==f_power)
	{
		QString s1=op1->print(),s2=op2->print();
		if(op1->id==f_plus || op1->id==f_minus || op1->id==f_times || op1->id==f_div || op1->id==f_power)
			s1='('+s1+')';
		if(op2->id==f_plus || op2->id==f_minus || op2->id==f_times || op2->id==f_div)
			s2='('+s2+')';
		return s1+'^'+s2;
	}
	else if(id==f_less || id==f_greater || id==f_equal)
	{
		return op1->print()+rels[id-f_less]+op2->print();
	}
	else if(id==f_or)
	{
		return op1->print()+'|'+op2->print();
	}
	else if(id==f_and)
	{
		QString s1=op1->print(),s2=op2->print();
		if(op1->id==f_or) s1='['+s1+']';
		if(op2->id==f_or) s2='['+s2+']';
		return s1+'&'+s2;
	}
	else if(id==f_unary_minus)
	{
		QString s=op1->print();
		if(op1->id==f_plus || op1->id==f_minus || op1->id==f_times || op1->id==f_div || op1->id==f_power)
			s='('+s+')';
		return '-'+s;
	}
	else if(id==f_sqr)
	{
		return "sqr("+op1->print()+")";
	}
	else if(id==f_exp)
	{
		return "exp("+op1->print()+")";
	}
	else if(id==f_log)
	{
		return "log("+op1->print()+")";
	}
	else if(id==f_none)
	{
		return QString::number(value);
	}
	else if(id==f_int)
	{
		return QString::number(intvalue);
	}
	else if(id>=0 && id<n_named_counters)
		return counter_name[id];
	else
		return "ERROR";
}

