#include "historywidget.h"


void historywidget::show_hg()
{
	yAxis.setEnabled(false);
	isoLines.setEnabled(false);
	activityType.setEnabled(true);
	yRanges.setEnabled(false);
	yRanges.setChecked(false);
	yStep.setEnabled(false);
	hg.show();
	cl.hide();
	ch.hide();
}
void historywidget::show_cl()
{
	xAxis.setEnabled(true);
	yAxis.setEnabled(true);
	isoLines.setEnabled(true);
	activityType.setEnabled(false);
	graphRanges.setEnabled(true);
	yRanges.setEnabled(true);
	yStep.setEnabled(true);
	cl.show();
	hg.hide();
	ch.hide();
}
void historywidget::show_ch()
{
	xAxis.setEnabled(false);
	yAxis.setEnabled(false);
	isoLines.setEnabled(false);
	activityType.setEnabled(false);
	graphRanges.setEnabled(false);
	ch.show();
	hg.hide();
	cl.hide();
}

void historywidget::set_levels_cumulative(bool b)
{
	cout<<"levels_cumulative="<<b<<endl;
	levels_cumulative=b;
	if(!b)
	{
		if(b_exp.isChecked())
		{
			b_int.setChecked(false);
			b_beg.setChecked(false);
			cur_level=2;
		}
		else if(b_int.isChecked())
		{
			b_beg.setChecked(false);
			cur_level=1;
		}
		else if(!b_beg.isChecked())
		{
			b_exp.setChecked(true);
			cur_level=2;
		}
		else
			cur_level=0;
	}
}

void historywidget::fill_occurence()
{
	cout<<"fill_occurence"<<endl;
	hg.reset();
	try
	{
		for(int i=0;i<h[cur_level].size();++i)
		{
			if(!satisfies_condition(i)) continue;
			Eval.refresh(&(h[cur_level][i]));
			hg.add_result(Eval.eval(f_x));
		}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		hg.reset();
	}
	redraw_hg();
}
void historywidget::fill_cloud()
{
	cout<<"fill_cloud"<<endl;
	cl.reset();
	try
	{
		for(int i=0;i<h[cur_level].size();++i)
		{
			if(!satisfies_condition(i)) continue;
			Eval.refresh(&(h[cur_level][i]));
			cl.add_point(Eval.eval(f_x),Eval.eval(f_y));
		}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		hg.reset();
	}
	cl.choose_step_x();
	cl.choose_step_y();
	steps_from_graph();
	redraw_cl();
}
void historywidget::fill_activity()
{
	if(activity_day.isChecked())
		fill_activity_day();
	else if(activity_month.isChecked())
		fill_activity_month();
	else if(activity_year.isChecked())
		fill_activity_year();
	else
	{
		activity_hour.setChecked(true);
		fill_activity_hour();
	}
	redraw_hg();
}
void historywidget::fill_activity_hour()
{
	cout<<"fill_activity_hour"<<endl;
	hg.reset();
	try
	{
		bool b[n_stand_levels];
		b[0]=b_beg.isChecked();
		b[1]=b_int.isChecked();
		b[2]=b_exp.isChecked();
		for(int j=0;j<n_stand_levels;++j)
			if(b[j])
				for(int i=0;i<h[j].size();++i)
				{
					if(!satisfies_condition(j,i)) continue;
					hg.add_result(h[j][i].hour);
				}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		hg.reset();
	}
	hg.strings_on_x=false;
	hg.prec=0;
	hg.min_x=0;hg.max_x=24;
	hg.x_axis="hour";
	redraw_hg();
}
void historywidget::fill_activity_day()
{
	cout<<"fill_activity_day"<<endl;
	hg.reset();
	try
	{
		bool b[n_stand_levels];
		b[0]=b_beg.isChecked();
		b[1]=b_int.isChecked();
		b[2]=b_exp.isChecked();
		for(int j=0;j<n_stand_levels;++j)
			if(b[j])
				for(int i=0;i<h[j].size();++i)
				{
					if(!satisfies_condition(j,i)) continue;
					hg.add_result(h[j][i].day_of_week);
				}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		hg.reset();
	}
	hg.strings_on_x=true;
	hg.strings.clear();
	for(int i=1;i<=7;++i) hg.strings << QDate::shortDayName(i);
	hg.min_x=0;hg.max_x=7;
	hg.x_axis="day";
	redraw_hg();
}
void historywidget::fill_activity_month()
{
	cout<<"fill_activity_month"<<endl;
	hg.reset();
	try
	{
		bool b[n_stand_levels];
		b[0]=b_beg.isChecked();
		b[1]=b_int.isChecked();
		b[2]=b_exp.isChecked();
		for(int j=0;j<n_stand_levels;++j)
			if(b[j])
				for(int i=0;i<h[j].size();++i)
				{
					if(!satisfies_condition(j,i)) continue;
					hg.add_result(h[j][i].month);
				}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		hg.reset();
	}
	hg.strings_on_x=true;
	hg.strings.clear();
	for(int i=1;i<=12;++i) hg.strings << QDate::shortMonthName(i);
	hg.min_x=1;hg.max_x=12;
	hg.x_axis="month";
	redraw_hg();
}
void historywidget::fill_activity_year()
{
	cout<<"fill_activity_year"<<endl;
	hg.reset();
	try
	{
		bool b[n_stand_levels];
		b[0]=b_beg.isChecked();
		b[1]=b_int.isChecked();
		b[2]=b_exp.isChecked();
		for(int j=0;j<n_stand_levels;++j)
			if(b[j])
				for(int i=0;i<h[j].size();++i)
				{
					if(!satisfies_condition(j,i)) continue;
					hg.add_result(h[j][i].year);
				}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		hg.reset();
	}
	hg.strings_on_x=false;
	hg.x_axis="year";
	redraw_hg();
}
void historywidget::fill_styles()
{
	cout<<"fill_styles"<<endl;
	ch.reset();
	try
	{
		bool b[n_stand_levels];
		b[0]=b_beg.isChecked();
		b[1]=b_int.isChecked();
		b[2]=b_exp.isChecked();
		for(int j=0;j<n_stand_levels;++j)
			if(b[j])
				for(int i=0;i<h[j].size();++i)
				{
					if(!satisfies_condition(j,i)) continue;
					if(h[j][i].flagging)
						++ch.num[1];
					else
						++ch.num[0];
				}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		ch.reset();
	}
	redraw_ch();
}
void historywidget::fill_levels()
{
	cout<<"fill_levels"<<endl;
	ch.reset();
	try
	{
		for(int j=0;j<n_stand_levels;++j)
			for(int i=0;i<h[j].size();++i)
			{
				if(!satisfies_condition(j,i)) continue;
				++ch.num[h[j][i].level];
			}
	}
	catch(exceval e)
	{
		cout<<"error!"<<endl;
		ch.reset();
	}
	redraw_ch();
}

void historywidget::redraw_hg()
{
	hg.fill_map();
	hg.repaint();
}
void historywidget::redraw_cl()
{
	cl.repaint();
}
void historywidget::redraw_ch()
{
	ch.repaint();
}

void historywidget::show_occurence()
{
	b_occurence.setChecked(true);
	set_levels_cumulative(false);
	graphLevel.setEnabled(true);
	isoLines.setVisible(true);
	activityType.setVisible(false);
	graphRanges.setEnabled(true);
	xAxis.setEnabled(true);
	
	hg.strings_on_x=false;
	hg.y_axis="occurence";
	hg.color=QColor(0,101,206);
	hg.color_border=QColor(0,0,132);
	hg.prec=2;
	hg.step_x=1;
	steps_from_graph();
	
	fill_occurence();
	
	show_hg();
}
void historywidget::show_cloud()
{
	b_cloud.setChecked(true);
	set_levels_cumulative(false);
	graphLevel.setEnabled(true);
	isoLines.setVisible(true);
	activityType.setVisible(false);
	
	cl.color_new=QColor(128,200,255);
	cl.color_border_new=QColor(192,192,255);
	cl.color_border_old=cl.color_old=QColor(0,0,0);
	cl.reset();
	
	fill_cloud();
	
	show_cl();
}
void historywidget::show_activity()
{
	b_activity.setChecked(true);
	set_levels_cumulative(true);
	graphLevel.setEnabled(true);
	isoLines.setVisible(false);
	activityType.setVisible(true);
	graphRanges.setEnabled(false);
	xAxis.setEnabled(false);
		
	hg.y_axis="occurence";
	hg.color=QColor(0,101,206);
	hg.color_border=QColor(0,0,132);
	hg.y_axis="games";
	hg.step_x=1;
	
	fill_activity();
	
	show_hg();
}
void historywidget::show_styles()
{
	b_styles.setChecked(true);
	set_levels_cumulative(true);
	graphLevel.setEnabled(true);
	isoLines.setVisible(true);
	activityType.setVisible(false);
	
	ch.reset();
	ch.name[0]="Non-flagging";
	ch.name[1]="Flagging";
	ch.color[0]=QColor(128,0,0);
	ch.color[1]=QColor(0,0,128);
	
	fill_styles();
	
	show_ch();
}
void historywidget::show_levels()
{
	b_levels.setChecked(true);
	xAxis.setEnabled(false);
	yAxis.setEnabled(false);
	graphLevel.setEnabled(false);
	isoLines.setVisible(true);
	activityType.setVisible(false);
	
	ch.reset();
	ch.name[1]="Beginner";
	ch.name[2]="Intermediate";
	ch.name[3]="Expert";
	ch.color[1]=QColor(255,255,0);
	ch.color[2]=QColor(0,204,102);
	ch.color[3]=QColor(153,204,255);
	
	fill_levels();
	
	show_ch();
}

void historywidget::g_beg_chosen()
{
	cout<<"beg_chosen"<<endl;
	if(!levels_cumulative)
	{
		cout<<"non-cumulative"<<endl;
		if(!b_beg.isChecked())
			b_beg.setChecked(true);
		cur_level=0;
		b_int.setChecked(false);
		b_exp.setChecked(false);
	}
	refresh();
}
void historywidget::g_int_chosen()
{
	cout<<"int_chosen"<<endl;
	if(!levels_cumulative)
	{
		cout<<"non-cumulative"<<endl;
		if(!b_int.isChecked())
			b_int.setChecked(true);
		cur_level=1;
		b_beg.setChecked(false);
		b_exp.setChecked(false);
	}
	refresh();
}
void historywidget::g_exp_chosen()
{
	cout<<"exp_chosen"<<endl;
	if(!levels_cumulative)
	{
		cout<<"non-cumulative"<<endl;
		if(!b_exp.isChecked())
			b_exp.setChecked(true);
		cur_level=2;
		b_beg.setChecked(false);
		b_int.setChecked(false);
	}
	refresh();
}

void historywidget::check_beg()
{
	b_beg.setChecked(true);
	if(!levels_cumulative)
	{
		b_int.setChecked(false);
		b_exp.setChecked(false);
	}
}
void historywidget::check_int()
{
	b_int.setChecked(true);
	if(!levels_cumulative)
	{
		b_beg.setChecked(false);
		b_exp.setChecked(false);
	}
}
void historywidget::check_exp()
{
	b_exp.setChecked(true);
	if(!levels_cumulative)
	{
		b_beg.setChecked(false);
		b_int.setChecked(false);
	}
}

void historywidget::g_x_time_chosen()
{
	b_x_time.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("time");
	hg.x_axis=cl.x_axis="time";
	hg.show_first=false;
	refresh();
}
void historywidget::g_x_bbbvs_chosen()
{
	b_x_bbbvs.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("bbbv\\s");
	hg.x_axis=cl.x_axis="3BV/s";
	refresh();
}
void historywidget::g_x_zinis_chosen()
{
	b_x_zinis.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("zini\\s");
	hg.x_axis=cl.x_axis="ZiNi/s";
	refresh();
}
void historywidget::g_x_hzinis_chosen()
{
	b_x_hzinis.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("hzini\\s");
	hg.x_axis=cl.x_axis="HZiNi/s";
	refresh();
}
void historywidget::g_x_cls_chosen()
{
	b_x_cls.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("cl\\s");
	hg.x_axis=cl.x_axis="cl/s";
	refresh();
}
void historywidget::g_x_ioe_chosen()
{
	b_x_ioe.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("ioe");
	hg.x_axis=cl.x_axis="IOE";
	refresh();
}
void historywidget::g_x_bbbv_chosen()
{
	b_x_bbbv.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("bbbv");
	hg.x_axis=cl.x_axis="3BV";
	refresh();
}
void historywidget::g_x_zini_chosen()
{
	b_x_zini.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("zini");
	hg.x_axis=cl.x_axis="ZiNi";
	refresh();
}
void historywidget::g_x_hzini_chosen()
{
	b_x_hzini.setChecked(true);
	if(f_x) delete f_x;
	f_x=Parser.parse_formula("hzini");
	hg.x_axis=cl.x_axis="HZiNi";
	refresh();
}
void historywidget::g_x_custom_chosen()
{
	formula* f;
	if(b_x_custom_edit.text()=="") return;
	f=Parser.parse_formula(b_x_custom_edit.text());
	if(!f) return;
	b_x_custom.setChecked(true);
	if(f_x) delete f_x;
	f_x=f;
	hg.x_axis=cl.x_axis=b_x_custom_edit.text();
	refresh();
}
void historywidget::g_y_time_chosen()
{
	b_y_time.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("time");
	hg.y_axis=cl.y_axis="time";
	refresh();
}
void historywidget::g_y_bbbvs_chosen()
{
	b_y_bbbvs.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("bbbv\\s");
	hg.y_axis=cl.y_axis="3BV/s";
	refresh();
}
void historywidget::g_y_zinis_chosen()
{
	b_y_zinis.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("zini\\s");
	hg.y_axis=cl.y_axis="ZiNi/s";
	refresh();
}
void historywidget::g_y_hzinis_chosen()
{
	b_y_hzinis.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("hzini\\s");
	hg.y_axis=cl.y_axis="HZiNi/s";
	refresh();
}
void historywidget::g_y_cls_chosen()
{
	b_y_cls.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("cl\\s");
	hg.y_axis=cl.y_axis="cl/s";
	refresh();
}
void historywidget::g_y_ioe_chosen()
{
	b_y_ioe.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("ioe");
	hg.y_axis=cl.y_axis="IOE";
	refresh();
}
void historywidget::g_y_bbbv_chosen()
{
	b_y_bbbv.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("bbbv");
	hg.y_axis=cl.y_axis="3BV";
	refresh();
}
void historywidget::g_y_zini_chosen()
{
	b_y_zini.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("zini");
	hg.y_axis=cl.y_axis="ZiNi";
	refresh();
}
void historywidget::g_y_hzini_chosen()
{
	b_y_hzini.setChecked(true);
	if(f_y) delete f_y;
	f_y=Parser.parse_formula("hzini");
	hg.y_axis=cl.y_axis="HZiNi";
	refresh();
}
void historywidget::g_y_custom_chosen()
{
	formula* f;
	if(b_y_custom_edit.text()=="") return;
	f=Parser.parse_formula(b_y_custom_edit.text());
	if(!f) return;
	b_y_custom.setChecked(true);
	if(f_y) delete f_y;
	f_y=f;
	hg.y_axis=cl.y_axis=b_y_custom_edit.text();
	refresh();
}

void historywidget::adj_x_axis_clicked()
{
	if(xRanges.isChecked())
	{
		if(!b_cloud.isChecked())
		{
			cout<<"HG "<<(int)hg.min_x<<" "<<(int)hg.max_x<<endl;
			xMin.setRange((int)hg.min_x-1,(int)hg.max_x+1);
			xMax.setRange((int)hg.min_x-1,(int)hg.max_x+1);
			xMin.setValue((int)hg.min_x);
			xMax.setValue((int)hg.max_x);
		}
		else
		{
			xMin.setRange((int)cl.min_x-1,(int)cl.max_x+1);
			xMax.setRange((int)cl.min_x-1,(int)cl.max_x+1);
			xMin.setValue((int)cl.min_x);
			xMax.setValue((int)cl.max_x);
		}
	}
	else
		refresh();
	xMin.setEnabled(xRanges.isChecked());
	xMax.setEnabled(xRanges.isChecked());
}
void historywidget::adj_y_axis_clicked()
{
	if(xRanges.isChecked())
	{
		yMin.setRange((int)cl.min_y-1,(int)cl.max_y+1);
		yMax.setRange((int)cl.min_y-1,(int)cl.max_y+1);
		yMin.setValue((int)cl.min_y);
		yMax.setValue((int)cl.max_y);
	}
	else
		refresh();
	yMin.setEnabled(yRanges.isChecked());
	yMax.setEnabled(yRanges.isChecked());
}
void historywidget::adjust_x(int)
{
	if(!xMin.isEnabled() || !xMax.isEnabled()) return;
	hg.max_x=cl.max_x=xMax.value();
	hg.min_x=cl.min_x=xMin.value();
	if(!b_cloud.isChecked())
		redraw_hg();
	else
		redraw_cl();
}
void historywidget::adjust_y(int)
{
	if(!yMin.isEnabled() || !yMax.isEnabled()) return;
	cl.max_y=yMax.value();
	cl.min_y=yMin.value();
	redraw_cl();
}
void historywidget::adjust_x_step(double d)
{
	cl.step_x=hg.step_x=d;
	if(!b_cloud.isChecked())
		redraw_hg();
	else
		redraw_cl();
}
void historywidget::adjust_y_step(double d)
{
	cl.step_y=d;
	redraw_cl();
}
void historywidget::steps_from_graph()
{
	if(!b_cloud.isChecked())
	{
		xStep.setValue(hg.step_x);
	}
	else
	{
		xStep.setValue(cl.step_x);
		yStep.setValue(cl.step_y);
	}
}

void get_date_from_string(const QString& s,int& y,int& m,int &d)
{
	d=s.mid(0,2).toInt();
	m=s.mid(3,2).toInt();
	y=s.mid(6,4).toInt();
}

void historywidget::g_init_dates()
{
	if(!(date_condition_on=g_select_date.isChecked())) return;
	set_date_condition();
	g_date_min.setText(date_to_string(d_min.date()));
	if(d_min_utc) g_date_min.setText(g_date_min.text()+" UTC");
	g_date_max.setText(date_to_string(d_max.date()));
	if(d_max_utc) g_date_max.setText(g_date_max.text()+" UTC");
}
void historywidget::g_custom_cond_clicked()
{
	if(g_select_custom_on.isChecked())
		g_custom_cond();
	else
		refresh();
}
void historywidget::g_custom_cond()
{
	formula* f;
	if(g_select_custom_on.text()=="") return;
	f=Parser.parse_expression(g_select_custom_cond.text());
	if(!f) return;
	g_select_custom_on.setChecked(true);
	if(cond) delete cond;
	cond=f;
	refresh();
}

void historywidget::refresh_graph()
{
	if(!levels_cumulative)
	{
		if(cur_level==0)
			check_beg();
		else if(cur_level==1)
			check_int();
		else if(cur_level==2)
			check_exp();
	}
	if(b_occurence.isChecked())
	{
		fill_occurence();
	}
	else if(b_cloud.isChecked())
	{
		fill_cloud();
	}
	else if(b_activity.isChecked())
	{
		fill_activity();
	}
	else if(b_styles.isChecked())
	{
		fill_styles();
	}
	else if(b_levels.isChecked())
	{
		fill_levels();
	}
}

