#include "historywidget.h"

void historywidget::place_things()
{

	setLayout(&layout);
	layout.addWidget(&tab,0,0,1,1);
	
	tab.addTab(&graphs,"Graphs");
	tab.addTab(&tables,"Tables");
	tab.addTab(&search,"Search");
	tab.addTab(&irc,"IRC");
	tab.addTab(&density,"Density");
	
	graphs.setLayout(&graphs_layout);
	graphs_layout.setAlignment(Qt::AlignLeft);
	graphs_layout.addWidget(&graphType,0,0,1,1);
	graphs_layout.addWidget(&graphLevel,0,1,1,1);
	graphs_layout.addWidget(&xAxis,0,2,1,1);
	graphs_layout.addWidget(&yAxis,0,3,1,1);
	graphs_layout.addWidget(&isoLines,0,4,1,1);
	graphs_layout.addWidget(&activityType,0,4,1,1);
	graphs_layout.addWidget(&graphSelect,0,5,1,1);
	graphs_layout.addWidget(&graphRanges,0,6,1,1);
	graphs_layout.addWidget(&hg,1,0,1,7);
	graphs_layout.addWidget(&cl,1,0,1,7);
	graphs_layout.addWidget(&ch,1,0,1,7);
	
	graphType.setLayout(&graphType_layout);
	graphType_layout.setSpacing(3);
	graphType_layout.setMargin(3);
	graphType_layout.setAlignment(Qt::AlignTop);
	graphType_layout.addWidget(&b_occurence);
	graphType_layout.addWidget(&b_cloud);
	graphType_layout.addWidget(&b_activity);
	graphType_layout.addWidget(&b_styles);
	graphType_layout.addWidget(&b_levels);
	
	graphLevel.setLayout(&graphLevel_layout);
	graphLevel_layout.setAlignment(Qt::AlignTop);
	graphLevel_layout.setSpacing(3);
	graphLevel_layout.setMargin(3);
	graphLevel_layout.addWidget(&b_beg);
	graphLevel_layout.addWidget(&b_int);
	graphLevel_layout.addWidget(&b_exp);
	
	xAxis.setLayout(&xAxis_layout);
	xAxis_layout.setSpacing(3);
	xAxis_layout.setMargin(3);
	xAxis_layout.setAlignment(Qt::AlignTop);
	xAxis_layout.addWidget(&b_x_time);
	xAxis_layout.addWidget(&b_x_bbbvs);
	xAxis_layout.addWidget(&b_x_zinis);
	xAxis_layout.addWidget(&b_x_hzinis);
	xAxis_layout.addWidget(&b_x_cls);
	xAxis_layout.addWidget(&b_x_ioe);
//	xAxis_layout.addWidget(&b_x_bbbv);
//	xAxis_layout.addWidget(&b_x_zini);
//	xAxis_layout.addWidget(&b_x_hzini);
	xAxis_layout.addWidget(&b_x_custom);
	xAxis_layout.addWidget(&b_x_custom_edit);
	xAxis_layout.addWidget(&b_x_custom_apply);
	
	yAxis.setLayout(&yAxis_layout);
	yAxis_layout.setSpacing(3);
	yAxis_layout.setMargin(3);
	yAxis_layout.setAlignment(Qt::AlignTop);
	yAxis_layout.addWidget(&b_y_time);
	yAxis_layout.addWidget(&b_y_bbbvs);
	yAxis_layout.addWidget(&b_y_zinis);
	yAxis_layout.addWidget(&b_y_hzinis);
	yAxis_layout.addWidget(&b_y_cls);
	yAxis_layout.addWidget(&b_y_ioe);
//	yAxis_layout.addWidget(&b_y_bbbv);
//	yAxis_layout.addWidget(&b_y_zini);
//	yAxis_layout.addWidget(&b_y_hzini);
	yAxis_layout.addWidget(&b_y_custom);
	yAxis_layout.addWidget(&b_y_custom_edit);
	yAxis_layout.addWidget(&b_y_custom_apply);
	
	isoLines.setLayout(&isoLines_layout);
	isoLines_layout.setSpacing(3);
	isoLines_layout.setMargin(3);
	isoLines_layout.setAlignment(Qt::AlignTop);
	isoLines_layout.addWidget(&iso_none);
	isoLines_layout.addWidget(&iso_lines);
	isoLines_layout.addWidget(&iso_hyperbolas);

	activityType.setLayout(&activityType_layout);
	activityType_layout.setSpacing(3);
	activityType_layout.setMargin(3);
	activityType_layout.setAlignment(Qt::AlignTop);
	activityType_layout.addWidget(&activity_hour);
	activityType_layout.addWidget(&activity_day);
	activityType_layout.addWidget(&activity_month);
	activityType_layout.addWidget(&activity_year);
	
	graphSelect.setLayout(&graphSelect_layout);
	graphSelect_layout.setSpacing(0);
	graphSelect_layout.setMargin(3);
	graphSelect_layout.setAlignment(Qt::AlignTop | Qt::AlignLeft);
	graphSelect_layout.addWidget(&g_select_f,0,0,1,2);
	graphSelect_layout.addWidget(&g_select_nf,0,2,1,2);
	graphSelect_layout.addWidget(&g_select_date,1,1,1,4);
	graphSelect_layout.addWidget(&g_date_min,2,0,1,1);
	graphSelect_layout.addWidget(&g_date,2,1,1,2);	
	graphSelect_layout.addWidget(&g_date_max,2,3,1,1);
	graphSelect_layout.addWidget(&g_date_today,3,0,1,1);
	graphSelect_layout.addWidget(&g_date_week,3,1,1,1);
	graphSelect_layout.addWidget(&g_date_month,3,2,1,1);
	graphSelect_layout.addWidget(&g_date_year,3,3,1,1);
	graphSelect_layout.addWidget(&g_date_ar,4,0,1,4);
	graphSelect_layout.addWidget(&g_select_custom_on,5,0,1,4);
	graphSelect_layout.addWidget(&g_select_custom_cond,6,0,1,4);
	graphSelect_layout.addWidget(&g_select_custom_apply,7,0,1,4);
	
	graphRanges.setLayout(&graphRanges_layout);
	graphRanges_layout.setSpacing(3);
	graphRanges_layout.setMargin(3);
	graphRanges_layout.setAlignment(Qt::AlignTop);
	graphRanges_layout.addWidget(&xRanges,0,0,1,4);
	graphRanges_layout.addWidget(&l_xMin,1,0,1,1);
	graphRanges_layout.addWidget(&xMin,1,1,1,1);
	graphRanges_layout.addWidget(&l_xMax,1,2,1,1);
	graphRanges_layout.addWidget(&xMax,1,3,1,1);
	graphRanges_layout.addWidget(&l_xStep,2,0,1,2);
	graphRanges_layout.addWidget(&xStep,2,2,1,2);
	graphRanges_layout.addWidget(&yRanges,3,0,1,4);
	graphRanges_layout.addWidget(&l_yMin,4,0,1,1);
	graphRanges_layout.addWidget(&yMin,4,1,1,1);
	graphRanges_layout.addWidget(&l_yMax,4,2,1,1);
	graphRanges_layout.addWidget(&yMax,4,3,1,1);
	graphRanges_layout.addWidget(&l_yStep,5,0,1,2);
	graphRanges_layout.addWidget(&yStep,5,2,1,2);
	
	graphType.setTitle("Type");
	b_occurence.setText("Occurence");
	b_cloud.setText("Cloud");
	b_activity.setText("Activity");
	b_styles.setText("Styles chart");
	b_levels.setText("Levels chart");

	graphLevel.setTitle("Level");
	b_beg.setText("Beg");
	b_int.setText("Int");
	b_exp.setText("Exp");
	
	xAxis.setTitle("X");
	b_x_time.setText("Time");
	b_x_bbbvs.setText("3BV/s");
	b_x_zinis.setText("ZiNi/s");
	b_x_hzinis.setText("HZiNi/s");
	b_x_cls.setText("Cl/s");
	b_x_ioe.setText("IOE");
	b_x_bbbv.setText("3BV");
	b_x_zini.setText("ZiNi");
	b_x_hzini.setText("HZiNi");
	b_x_custom.setText("Custom:");
	b_x_custom_apply.setText("Apply");
	
	yAxis.setTitle("Y");
	b_y_time.setText("Time");
	b_y_bbbvs.setText("3BV/s");
	b_y_zinis.setText("ZiNi/s");
	b_y_hzinis.setText("HZiNi/s");
	b_y_cls.setText("Cl/s");
	b_y_ioe.setText("IOE");
	b_y_bbbv.setText("3BV");
	b_y_zini.setText("ZiNi");
	b_y_hzini.setText("HZiNi");
	b_y_custom.setText("Custom:");
	b_y_custom_apply.setText("Apply");
	
	isoLines.setTitle("Iso lines");
	iso_none.setText("None");
	iso_lines.setText("Lines");
	iso_hyperbolas.setText("Hyperbolas");
		
	activityType.setTitle("Activity");
	activity_hour.setText("Hourly");
	activity_day.setText("Daily");
	activity_month.setText("Monthly");
	activity_year.setText("Yearly");
	
	graphSelect.setTitle("Conditions");
	g_select_f.setText("F");
	g_select_nf.setText("NF");
	g_select_date.setText("Finished between");
	g_date.setText("and");
	g_date.setAlignment(Qt::AlignHCenter);
	g_date_today.setText("today");
	g_date_week.setText("this week");
	g_date_month.setText("this month");
	g_date_year.setText("this year");
	g_date_ar.setText("this AR");
	g_date_min.setMaxLength(14);
	g_date_max.setMaxLength(14);
	g_select_custom_on.setText("Custom condition:");
	g_select_custom_apply.setText("Apply");

	graphRanges.setTitle("Graph parameters");
	xRanges.setText("X axis:");
	l_xMin.setText("Min:");
	l_xMax.setText("Max:");
	l_xStep.setText("Step:");
	xStep.setRange(0.01,100);
	xStep.setValue(1);
	xStep.setSingleStep(0.1);
	yRanges.setText("Y axis:");
	l_yMin.setText("Min:");
	l_yMax.setText("Max:");
	l_yStep.setText("Step:");
	yStep.setRange(0.01,100);
	yStep.setValue(1);
	yStep.setSingleStep(0.1);
	
 	// TABLES
	
	tables.setLayout(&tables_layout);
	tables_layout.setAlignment(Qt::AlignLeft);
	tables_layout.addWidget(&tableType,0,0,2,1);
	tables_layout.addWidget(&tableLevel,0,1,2,1);
	tables_layout.addWidget(&tableCounter,0,2,2,1);
	tables_layout.addWidget(&tableSelect,0,3,2,1);
	tables_layout.addWidget(&tableRanges,0,4,2,1);
	tables_layout.addWidget(&tableBetter,1,4,1,1);
	tables_layout.addWidget(&table,2,0,1,5);
	
	tableType.setLayout(&tableType_layout);
	tableType_layout.setSpacing(3);
	tableType_layout.setMargin(3);
	tableType_layout.setAlignment(Qt::AlignTop);
	tableType_layout.addWidget(&records);
	tableType_layout.addWidget(&toplists);
	tableType_layout.addWidget(&evolution);

	tableType_layout.addWidget(&daily);
	tableType_layout.addWidget(&details);
	
	tableLevel.setLayout(&tableLevel_layout);
	tableLevel_layout.setSpacing(3);
	tableLevel_layout.setMargin(3);
	tableLevel_layout.setAlignment(Qt::AlignTop);
	tableLevel_layout.addWidget(&t_beg);
	tableLevel_layout.addWidget(&t_int);
	tableLevel_layout.addWidget(&t_exp);

	tableCounter.setLayout(&tableCounter_layout);
	tableCounter_layout.setSpacing(3);
	tableCounter_layout.setMargin(3);
	tableCounter_layout.setAlignment(Qt::AlignTop);
	tableCounter_layout.addWidget(&tc_time,0,0,1,2);
	tableCounter_layout.addWidget(&tc_bbbvs,1,0,1,1);
	tableCounter_layout.addWidget(&tc_zinis,2,0,1,1);
	tableCounter_layout.addWidget(&tc_hzinis,3,0,1,1);
	tableCounter_layout.addWidget(&tc_cls,4,0,1,1);
	tableCounter_layout.addWidget(&tc_ioe,4,1,1,1);
	tableCounter_layout.addWidget(&tc_bbbv,1,1,1,1);
	tableCounter_layout.addWidget(&tc_zini,2,1,1,1);
	tableCounter_layout.addWidget(&tc_hzini,3,1,1,1);
	tableCounter_layout.addWidget(&tc_custom,5,0,1,2);
	tableCounter_layout.addWidget(&tc_custom_edit,6,0,1,2);
	tableCounter_layout.addWidget(&tc_custom_apply,7,0,1,2);

	tableSelect.setLayout(&tableSelect_layout);
	tableSelect_layout.setSpacing(0);
	tableSelect_layout.setMargin(3);
	tableSelect_layout.setAlignment(Qt::AlignTop | Qt::AlignLeft);
	tableSelect_layout.addWidget(&t_select_f,0,0,1,2);
	tableSelect_layout.addWidget(&t_select_nf,0,2,1,2);
	tableSelect_layout.addWidget(&t_select_date,1,1,1,4);
	tableSelect_layout.addWidget(&t_date_min,2,0,1,1);
	tableSelect_layout.addWidget(&t_date,2,1,1,2);	
	tableSelect_layout.addWidget(&t_date_max,2,3,1,1);
	tableSelect_layout.addWidget(&t_date_today,3,0,1,1);
	tableSelect_layout.addWidget(&t_date_week,3,1,1,1);
	tableSelect_layout.addWidget(&t_date_month,3,2,1,1);
	tableSelect_layout.addWidget(&t_date_year,3,3,1,1);
	tableSelect_layout.addWidget(&t_date_ar,4,0,1,4);
	tableSelect_layout.addWidget(&t_select_custom_on,5,0,1,4);
	tableSelect_layout.addWidget(&t_select_custom_cond,6,0,1,4);
	tableSelect_layout.addWidget(&t_select_custom_apply,7,0,1,4);

	tableRanges.setLayout(&tableRanges_layout);
	tableRanges_layout.setSpacing(3);
	tableRanges_layout.setMargin(3);
	tableRanges_layout.setAlignment(Qt::AlignTop);
	tableRanges_layout.addWidget(&l_step,0,0,1,1);
	tableRanges_layout.addWidget(&step,0,1,1,1);

	tableBetter.setLayout(&tableBetter_layout);
	tableBetter_layout.setSpacing(3);
	tableBetter_layout.setMargin(3);
	tableBetter_layout.setAlignment(Qt::AlignTop);
	tableBetter_layout.addWidget(&t_l_what_is_better,0,0,1,1);
	tableBetter_layout.addWidget(&t_what_is_better,0,1,1,1);

	tableType.setTitle("Type");
	records.setText("Overview");
	toplists.setText("Top Lists");
	evolution.setText("Evolution");
	daily.setText("Daily stats");
	details.setText("Analysis");
	
	tableLevel.setTitle("Level");
	t_beg.setText("Beginner");
	t_int.setText("Intermediate");
	t_exp.setText("Expert");
	
	tableCounter.setTitle("Index");
	tc_time.setText("Time");
	tc_bbbvs.setText("3BV/s");
	tc_zinis.setText("ZiNi/s");
	tc_hzinis.setText("HZiNi/s");
	tc_cls.setText("Cl/s");
	tc_ioe.setText("IOE");
	tc_bbbv.setText("3BV");
	tc_zini.setText("ZiNi");
	tc_hzini.setText("HZiNi");
	tc_custom.setText("Custom:");
	tc_custom_apply.setText("Apply");
		
	tableSelect.setTitle("Conditions");
	t_select_f.setText("F");
	t_select_nf.setText("NF");
	t_select_date.setText("Finished between");
	t_date.setText("and");
	t_date.setAlignment(Qt::AlignHCenter);
	t_date_today.setText("today");
	t_date_week.setText("this week");
	t_date_month.setText("this month");
	t_date_year.setText("this year");
	t_date_ar.setText("this AR");
	t_select_custom_on.setText("Custom condition:");
	t_select_custom_apply.setText("Apply");

	tableRanges.setTitle("Analysis step");
	l_step.setText("Step:");
	step.setRange(0.01,99.99);
	step.setValue(1.0);
	step.setSingleStep(0.1);
	
	tableBetter.setTitle("Sort order");
	t_l_what_is_better.setText("Better is ");
	t_what_is_better.setEditable(false);
	t_what_is_better.addItem("Lower");
	t_what_is_better.addItem("Higher");
	
	// SEARCH
	search.setLayout(&search_layout);
	search_layout.setAlignment(Qt::AlignTop);
	search_layout.addWidget(&searchLine,0,0,1,2);
	search_layout.addWidget(&searchLevel,1,0,1,1);
	search_layout.addWidget(&searchApply,1,1,1,1);
	search_layout.addWidget(&searchTable,2,0,1,2);
	searchApply.setText("Search");
	
	searchLevel.setLayout(&searchLevel_layout);
	searchLevel_layout.addWidget(&searchBeg);
	searchLevel_layout.addWidget(&searchInt);
	searchLevel_layout.addWidget(&searchExp);
	searchLevel_layout.addWidget(&searchAll);
	searchBeg.setText("Beg");
	searchInt.setText("Int");
	searchExp.setText("Exp");
	searchAll.setText("All");
	searchAll.setChecked(true);

	// IRC
	irc.setLayout(&irc_layout);
	irc_layout.setSpacing(3);
	irc_layout.setMargin(1);
	irc_layout.setAlignment(Qt::AlignTop | Qt::AlignLeft);
	
	irc_layout.addWidget(&l_recs,0,0,1,3);
	irc_layout.addWidget(&recs,1,0,1,1);
	irc_layout.addWidget(&b_recs,1,1,1,2);
	
	irc_layout.addWidget(&l_avgs,2,0,1,3);
	irc_layout.addWidget(&avgs,3,0,1,1);
	irc_layout.addWidget(&b_avgs,3,1,1,2);
	
	irc_layout.addWidget(&l_ar,4,0,1,3);
	irc_layout.addWidget(&ar,5,0,1,1);
	irc_layout.addWidget(&b_ar,5,1,1,2);
	
	irc_layout.addWidget(&l_today,6,0,1,3);
	irc_layout.addWidget(&today,7,0,1,1);
	irc_layout.addWidget(&b_today,7,1,1,2);
	irc_layout.addWidget(&today_beg,8,0,1,1);
	irc_layout.addWidget(&today_int,9,0,1,1);
	irc_layout.addWidget(&today_exp,10,0,1,1);
	
	l_recs.setText("Records:");
	b_recs.setText("Copy");
	l_avgs.setText("Averages:");
	b_avgs.setText("Copy");
	l_ar.setText("AR:");
	b_ar.setText("Copy");
	l_today.setText("Today:");
	b_today.setText("Copy");
	today_beg.setText("Beginner");
	today_int.setText("Intermediate");
	today_exp.setText("Expert"); 
	today_exp.setChecked(true);
	
	// DENSITY
	density.setLayout(&density_layout);
	density_layout.setSpacing(3);
	density_layout.setMargin(1);
	density_layout.addWidget(&dens_type,0,0,1,1);
	density_layout.addWidget(&dens_level,0,1,1,1);
	density_layout.addWidget(&dens_table,1,0,1,2);
	
	dens_type.setLayout(&dens_type_layout);
	dens_type_layout.addWidget(&dens_finished);
	dens_type_layout.addWidget(&dens_unfinished);
	
	dens_level.setLayout(&dens_level_layout);
	dens_level_layout.addWidget(&dens_beg,0,0,1,1);
	dens_level_layout.addWidget(&dens_int,0,1,1,1);
	dens_level_layout.addWidget(&dens_exp,1,0,1,1);
	dens_level_layout.addWidget(&dens_mega,1,1,1,1);
	
	dens_finished.setText("Finished");
	dens_unfinished.setText("Unfinished");
	dens_finished.setChecked(true);
	
	dens_beg.setText("Beginner");
	dens_int.setText("Intermediate");
	dens_exp.setText("Expert");
	dens_mega.setText("24x30");
	dens_beg.setChecked(true);
//	dens_mega.setChecked(true);
}

void historywidget::connect_things()
{
	
	// connect things
	
	connect(&tab,SIGNAL(currentChanged(int)),this,SLOT(tab_changed(int)));
	
	connect(&b_occurence,SIGNAL(clicked()),this,SLOT(show_occurence()));
	connect(&b_cloud,SIGNAL(clicked()),this,SLOT(show_cloud()));
	connect(&b_activity,SIGNAL(clicked()),this,SLOT(show_activity()));
	connect(&b_styles,SIGNAL(clicked()),this,SLOT(show_styles()));
	connect(&b_levels,SIGNAL(clicked()),this,SLOT(show_levels()));
	
	connect(&b_beg,SIGNAL(clicked()),this,SLOT(g_beg_chosen()));
	connect(&b_int,SIGNAL(clicked()),this,SLOT(g_int_chosen()));
	connect(&b_exp,SIGNAL(clicked()),this,SLOT(g_exp_chosen()));
	
	connect(&b_x_time,SIGNAL(clicked()),this,SLOT(g_x_time_chosen()));	
	connect(&b_x_bbbvs,SIGNAL(clicked()),this,SLOT(g_x_bbbvs_chosen()));	
	connect(&b_x_zinis,SIGNAL(clicked()),this,SLOT(g_x_zinis_chosen()));	
	connect(&b_x_hzinis,SIGNAL(clicked()),this,SLOT(g_x_hzinis_chosen()));	
	connect(&b_x_cls,SIGNAL(clicked()),this,SLOT(g_x_cls_chosen()));	
	connect(&b_x_ioe,SIGNAL(clicked()),this,SLOT(g_x_ioe_chosen()));	
	connect(&b_x_bbbv,SIGNAL(clicked()),this,SLOT(g_x_bbbv_chosen()));	
	connect(&b_x_zini,SIGNAL(clicked()),this,SLOT(g_x_zini_chosen()));
	connect(&b_x_hzini,SIGNAL(clicked()),this,SLOT(g_x_hzini_chosen()));
	connect(&b_x_custom,SIGNAL(clicked()),this,SLOT(g_x_custom_chosen()));
	connect(&b_x_custom_apply,SIGNAL(clicked()),this,SLOT(g_x_custom_chosen()));
	
	connect(&b_y_time,SIGNAL(clicked()),this,SLOT(g_y_time_chosen()));	
	connect(&b_y_bbbvs,SIGNAL(clicked()),this,SLOT(g_y_bbbvs_chosen()));	
	connect(&b_y_zinis,SIGNAL(clicked()),this,SLOT(g_y_zinis_chosen()));	
	connect(&b_y_hzinis,SIGNAL(clicked()),this,SLOT(g_y_hzinis_chosen()));	
	connect(&b_y_cls,SIGNAL(clicked()),this,SLOT(g_y_cls_chosen()));	
	connect(&b_y_ioe,SIGNAL(clicked()),this,SLOT(g_y_ioe_chosen()));	
	connect(&b_y_bbbv,SIGNAL(clicked()),this,SLOT(g_y_bbbv_chosen()));	
	connect(&b_y_zini,SIGNAL(clicked()),this,SLOT(g_y_zini_chosen()));	
	connect(&b_y_hzini,SIGNAL(clicked()),this,SLOT(g_y_hzini_chosen()));	
	connect(&b_y_custom,SIGNAL(clicked()),this,SLOT(g_y_custom_chosen()));	
	connect(&b_y_custom_apply,SIGNAL(clicked()),this,SLOT(g_y_custom_chosen()));	
	
	connect(&activity_hour,SIGNAL(clicked()),this,SLOT(show_activity()));
	connect(&activity_day,SIGNAL(clicked()),this,SLOT(show_activity()));
	connect(&activity_month,SIGNAL(clicked()),this,SLOT(show_activity()));
	connect(&activity_year,SIGNAL(clicked()),this,SLOT(show_activity()));
	
	// SELECT
	connect(&g_select_f,SIGNAL(clicked()),this,SLOT(refresh()));
	connect(&g_select_nf,SIGNAL(clicked()),this,SLOT(refresh()));
	connect(&g_select_date,SIGNAL(clicked()),this,SLOT(refresh()));
	connect(&g_date_min,SIGNAL(editingFinished()),this,SLOT(g_init_dates()));
	connect(&g_date_max,SIGNAL(editingFinished()),this,SLOT(g_init_dates()));
	connect(&g_date_today,SIGNAL(clicked()),this,SLOT(set_date_today()));
	connect(&g_date_week,SIGNAL(clicked()),this,SLOT(set_date_week()));
	connect(&g_date_month,SIGNAL(clicked()),this,SLOT(set_date_month()));
	connect(&g_date_year,SIGNAL(clicked()),this,SLOT(set_date_year()));
	connect(&g_date_ar,SIGNAL(clicked()),this,SLOT(set_date_ar()));
	connect(&g_select_custom_on,SIGNAL(clicked()),this,SLOT(g_custom_cond_clicked()));
	connect(&g_select_custom_apply,SIGNAL(clicked()),this,SLOT(g_custom_cond()));
	
	connect(&xRanges,SIGNAL(clicked()),this,SLOT(adj_x_axis_clicked()));
	connect(&yRanges,SIGNAL(clicked()),this,SLOT(adj_y_axis_clicked()));

	connect(&xMin,SIGNAL(valueChanged(int)),this,SLOT(adjust_x(int)));
	connect(&xMax,SIGNAL(valueChanged(int)),this,SLOT(adjust_x(int)));
	connect(&yMin,SIGNAL(valueChanged(int)),this,SLOT(adjust_y(int)));
	connect(&yMax,SIGNAL(valueChanged(int)),this,SLOT(adjust_y(int)));

	connect(&xStep,SIGNAL(valueChanged(double)),this,SLOT(adjust_x_step(double)));
	connect(&yStep,SIGNAL(valueChanged(double)),this,SLOT(adjust_y_step(double)));

	// TABLES
	connect(&records,SIGNAL(clicked()),this,SLOT(show_records()));
	connect(&toplists,SIGNAL(clicked()),this,SLOT(show_toplists()));
	connect(&evolution,SIGNAL(clicked()),this,SLOT(show_evolution()));
	connect(&daily,SIGNAL(clicked()),this,SLOT(show_daily()));
	connect(&details,SIGNAL(clicked()),this,SLOT(show_details()));
	
	connect(&t_beg,SIGNAL(clicked()),this,SLOT(t_beg_chosen()));
	connect(&t_int,SIGNAL(clicked()),this,SLOT(t_int_chosen()));
	connect(&t_exp,SIGNAL(clicked()),this,SLOT(t_exp_chosen()));
	
	connect(&tc_time,SIGNAL(clicked()),this,SLOT(t_time_chosen()));	
	connect(&tc_bbbvs,SIGNAL(clicked()),this,SLOT(t_bbbvs_chosen()));	
	connect(&tc_zinis,SIGNAL(clicked()),this,SLOT(t_zinis_chosen()));	
	connect(&tc_hzinis,SIGNAL(clicked()),this,SLOT(t_hzinis_chosen()));	
	connect(&tc_cls,SIGNAL(clicked()),this,SLOT(t_cls_chosen()));	
	connect(&tc_ioe,SIGNAL(clicked()),this,SLOT(t_ioe_chosen()));	
	connect(&tc_bbbv,SIGNAL(clicked()),this,SLOT(t_bbbv_chosen()));	
	connect(&tc_zini,SIGNAL(clicked()),this,SLOT(t_zini_chosen()));
	connect(&tc_hzini,SIGNAL(clicked()),this,SLOT(t_hzini_chosen()));
	connect(&tc_custom,SIGNAL(clicked()),this,SLOT(t_custom_chosen()));
	connect(&tc_custom_apply,SIGNAL(clicked()),this,SLOT(t_custom_chosen()));

	connect(&t_select_f,SIGNAL(clicked()),this,SLOT(refresh()));
	connect(&t_select_nf,SIGNAL(clicked()),this,SLOT(refresh()));
	connect(&t_select_date,SIGNAL(clicked()),this,SLOT(refresh()));
	connect(&t_date_min,SIGNAL(editingFinished()),this,SLOT(t_init_dates()));
	connect(&t_date_max,SIGNAL(editingFinished()),this,SLOT(t_init_dates()));
	connect(&t_date_today,SIGNAL(clicked()),this,SLOT(set_date_today()));
	connect(&t_date_week,SIGNAL(clicked()),this,SLOT(set_date_week()));
	connect(&t_date_month,SIGNAL(clicked()),this,SLOT(set_date_month()));
	connect(&t_date_year,SIGNAL(clicked()),this,SLOT(set_date_year()));
	connect(&t_date_ar,SIGNAL(clicked()),this,SLOT(set_date_ar()));
	connect(&t_select_custom_on,SIGNAL(clicked()),this,SLOT(t_custom_cond_clicked()));
	connect(&t_select_custom_apply,SIGNAL(clicked()),this,SLOT(t_custom_cond()));	

	connect(&t_what_is_better,SIGNAL(currentIndexChanged(int)),this,SLOT(change_cur_better(int)));
	connect(&step,SIGNAL(valueChanged(double)),this,SLOT(a_step_changed(double)));
	
	connect(&searchApply,SIGNAL(clicked()),this,SLOT(makesearch()));
	searchApply.setDefault(true);
	searchApply.setAutoDefault(true);
	
	connect(&b_recs,SIGNAL(clicked()),this,SLOT(irc_copy_records()));
	connect(&b_avgs,SIGNAL(clicked()),this,SLOT(irc_copy_averages()));
	connect(&b_ar,SIGNAL(clicked()),this,SLOT(irc_copy_ar()));
	connect(&b_today,SIGNAL(clicked()),this,SLOT(irc_copy_today()));
	
	connect(&dens_finished,SIGNAL(clicked()),this,SLOT(show_density()));
	connect(&dens_unfinished,SIGNAL(clicked()),this,SLOT(show_density()));
	connect(&dens_beg,SIGNAL(clicked()),this,SLOT(show_density()));
	connect(&dens_int,SIGNAL(clicked()),this,SLOT(show_density()));
	connect(&dens_exp,SIGNAL(clicked()),this,SLOT(show_density()));
	connect(&dens_mega,SIGNAL(clicked()),this,SLOT(show_density()));
}

