#include "historywidget.h"


void historywidget::t_beg_chosen()
{
	cur_level=0;
	refresh();
}
void historywidget::t_int_chosen()
{
	cur_level=1;
	refresh();
}
void historywidget::t_exp_chosen()
{
	cur_level=2;
	refresh();
}

void historywidget::t_time_chosen()
{
	tc_time.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("time");
	cur_ind="Time";
	cur_better_is_higher=false;
	prec=2;
	change_a_step(1.0);
	round_up=true;
	refresh();
}
void historywidget::t_bbbvs_chosen()
{
	tc_bbbvs.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("bbbv\\s");
	cur_ind="3BV/s";
	cur_better_is_higher=true;
	prec=2;
	change_a_step(0.1);
	round_up=false;
	refresh();
}
void historywidget::t_zinis_chosen()
{
	tc_zinis.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("zini\\s");
	cur_ind="ZiNi/s";
	cur_better_is_higher=true;
	prec=2;
	change_a_step(0.1);
	round_up=false;
	refresh();
}
void historywidget::t_hzinis_chosen()
{
	tc_hzinis.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("hzini\\s");
	cur_ind="HZiNi/s";
	cur_better_is_higher=true;
	prec=2;
	change_a_step(0.1);
	round_up=false;
	refresh();
}
void historywidget::t_cls_chosen()
{
	tc_cls.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("cl\\s");
	cur_ind="Cl/s";
	cur_better_is_higher=true;
	prec=2;
	change_a_step(0.5);
	round_up=false;
	refresh();
}
void historywidget::t_ioe_chosen()
{
	tc_ioe.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("ioe");
	cur_ind="IOE";
	cur_better_is_higher=true;
	prec=3;
	change_a_step(0.05);
	round_up=false;
	refresh();
}
void historywidget::t_bbbv_chosen()
{
	tc_bbbv.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("bbbv");
	cur_ind="3BV";
	cur_better_is_higher=false;
	prec=0;
	change_a_step(1.0);
	round_up=false;
	refresh();
}
void historywidget::t_zini_chosen()
{
	tc_zini.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("zini");
	cur_ind="ZiNi";
	cur_better_is_higher=false;
	prec=0;
	change_a_step(1.0);
	round_up=false;
	refresh();
}
void historywidget::t_hzini_chosen()
{
	tc_hzini.setChecked(true);
	tableBetter.setEnabled(false);
	if(ind) delete ind;
	ind=Parser.parse_formula("hzini");
	cur_ind="HZiNi";
	cur_better_is_higher=false;
	prec=0;
	change_a_step(1.0);
	round_up=false;
	refresh();
}
void historywidget::t_custom_chosen()
{
	formula* f;
	if(tc_custom_edit.text()=="") return;
	f=Parser.parse_formula(tc_custom_edit.text());
	if(!f) return;
	tc_custom.setChecked(true);
	tableBetter.setEnabled(true);
	if(ind) delete ind;
	ind=f;
	cur_ind=b_x_custom_edit.text();

	cur_better_is_higher=false;
	prec=2;
	change_a_step(1.0);
	round_up=false;

	refresh();	
}

void historywidget::t_init_dates()
{
	if(!(date_condition_on=t_select_date.isChecked())) return;
	set_date_condition();
	t_date_min.setText(date_to_string(d_min.date()));
	if(d_min_utc) t_date_min.setText(g_date_min.text()+" UTC");
	t_date_max.setText(date_to_string(d_max.date()));
	if(d_max_utc) t_date_max.setText(g_date_max.text()+" UTC");
}

void historywidget::t_custom_cond_clicked()
{
	if(t_select_custom_on.isChecked())
		t_custom_cond();
	else
		refresh();
}

void historywidget::t_custom_cond()
{
	formula* f;
	if(t_select_custom_on.text()=="") return;
	f=Parser.parse_expression(t_select_custom_cond.text());
	if(!f) return;
	t_select_custom_on.setChecked(true);
	if(cond) delete cond;
	cond=f;
	refresh();
}

bool historywidget::t_satisfies_condition(int i)
{
	return t_satisfies_condition(cur_level,i);
}
bool historywidget::t_satisfies_condition(int level,int i)
{
	if(!(h[level][i].flagging&&t_select_f.isChecked()) &&
		!(!h[level][i].flagging&&t_select_nf.isChecked()))
		return false;
	if(t_select_date.isChecked())
	{
		QDateTime d=QDateTime(QDate(h[level][i].year,h[level][i].month,h[level][i].day),
					QTime(h[level][i].hour,h[level][i].minute,h[level][i].second));
		if((d_min_utc && d.toUTC()<d_min) ||
			(!d_min_utc && d<d_min))
			return false;
		if((d_max_utc && d.toUTC()>d_max) ||
			(!d_max_utc && d>d_max))
			return false;
	}
	if(t_select_custom_on.isChecked() && cond)
	{
		Eval.refresh(&h[level][i]);
		return Eval.eval_expr(cond);
	}
	return true;
}
void historywidget::change_cur_better(int i)
{
	cur_better_is_higher=i;
	refresh();
}
void historywidget::change_a_step(double s)
{
	step.setValue(s);
}
void historywidget::a_step_changed(double s)
{
	a_step=s;
	round_up = round_up && s==1.0;
}

void set_table_item(QTableWidget& t, int row, int column, double d, int prec)
{
	QTableWidgetItem* i=t.item(row,column);
	if(!i)
	{
		i=new QTableWidgetItem();
		t.setItem(row,column,i);
	}
	i->setFlags(i->flags() & (~Qt::ItemIsSelectable & ~Qt::ItemIsEditable));
	i->setText(QString::number(d,'f',prec));
}
void set_table_item(QTableWidget& t, int row, int column, const QString& s)
{
	QTableWidgetItem* i=t.item(row,column);
	if(!i)
	{
		i=new QTableWidgetItem(s);
		t.setItem(row,column,i);
	}
	else
		i->setText(s);
	i->setFlags(i->flags() & (~Qt::ItemIsSelectable & ~Qt::ItemIsEditable));
}


void add_table_item(QTableWidget& t, int row, int column, double d, int prec)
{
	QTableWidgetItem* i=t.item(row,column);
	double _d=i?i->text().toDouble()+d:d;
	if(!i)
	{
		i=new QTableWidgetItem();
		t.setItem(row,column,i);
	}
	i->setFlags(i->flags() & (~Qt::ItemIsSelectable & ~Qt::ItemIsEditable));
	i->setText(QString::number(_d,'f',prec));
}

void historywidget::show_records()
{
	formula* f_time=Parser.parse_formula("time");

	tableLevel.setEnabled(false);
	tableCounter.setEnabled(false);
	tableRanges.setEnabled(false);

	table.clear();
		
	table.setColumnCount(4);
	table.setRowCount(4+4*table_ctrs.size());
	
	table.setHorizontalHeaderItem(0,new QTableWidgetItem("Beginner"));
	table.setHorizontalHeaderItem(1,new QTableWidgetItem("Intermediate"));
	table.setHorizontalHeaderItem(2,new QTableWidgetItem("Expert"));
	table.setHorizontalHeaderItem(3,new QTableWidgetItem("Total"));
	table.setVerticalHeaderItem(0,new QTableWidgetItem("Games"));
	table.setVerticalHeaderItem(1,new QTableWidgetItem("F"));
	table.setVerticalHeaderItem(2,new QTableWidgetItem("NF"));
	table.setVerticalHeaderItem(3,new QTableWidgetItem("Total time"));
	for(int j=0;j<table_ctrs.size();++j)
	{
		table.setVerticalHeaderItem(4+4*j,new QTableWidgetItem(""));
		table.setVerticalHeaderItem(5+4*j,new QTableWidgetItem("Best "+table_headers[j]));
		table.setVerticalHeaderItem(6+4*j,new QTableWidgetItem("Avg "+table_headers[j]));
		table.setVerticalHeaderItem(7+4*j,new QTableWidgetItem("Worst "+table_headers[j]));
	}
	
	try
	{
		for(int l=0;l<n_stand_levels;++l)
		{
			QVector<double> best,worst,avg;
			double sum_time=0.0;
			int i,num_games=0,num_f=0,num_nf=0;
			for(i=0;i<h[l].size();++i)
			{
				if(!t_satisfies_condition(l,i)) continue;
				Eval.refresh(&(h[l][i]));
				for(int j=0;j<table_ctrs.size();++j)
				{
					best << Eval.eval(table_ctrs[j]);
					worst << best[j];
					avg << best[j];
				}
				sum_time+=Eval.eval(f_time);
				++num_games;
				if(h[l][i].flagging) ++num_f; else ++num_nf;
				break;
			}
			for(++i;i<h[l].size();++i)
			{
				if(!t_satisfies_condition(l,i)) continue;
				Eval.refresh(&(h[l][i]));
				for(int j=0;j<table_ctrs.size();++j)
				{
					double d=Eval.eval(table_ctrs[j]);
					if((d<best[j]) ^ better_is_higher[j]) best[j]=d;
					if((d>worst[j]) ^ better_is_higher[j]) worst[j]=d;
					avg[j]+=d;
				}
				sum_time+=Eval.eval(f_time);
				++num_games;
				if(h[l][i].flagging) ++num_f; else ++num_nf;
			}
			if(num_games)
				for(int j=0;j<table_ctrs.size();++j)
					avg[j]/=num_games;
			else
				continue;
			set_table_item(table,0,l, num_games,0);
			set_table_item(table,1,l, num_f,0);
			set_table_item(table,2,l, num_nf,0);
			set_table_item(table,3,l, sum_time,2);

			add_table_item(table,0,3, num_games,0);
			add_table_item(table,1,3, num_f,0);
			add_table_item(table,2,3, num_nf,0);
			add_table_item(table,3,3, sum_time,2);
			for(int j=0;j<table_ctrs.size();++j)
			{
				set_table_item(table,5+4*j,l, best[j],table_prec[j]);
				set_table_item(table,6+4*j,l, avg[j],table_avg_prec[j]);
				set_table_item(table,7+4*j,l, worst[j],table_prec[j]);
				
				add_table_item(table,5+4*j,3, best[j],table_prec[j]);
				add_table_item(table,6+4*j,3, avg[j],table_avg_prec[j]);
				add_table_item(table,7+4*j,3, worst[j],table_prec[j]);
			}
		}
	}
	catch(exceval)
	{
		msg("Oh shit, it can not be, it can not be!");
	}
	table.resizeRowsToContents();
	table.resizeColumnsToContents();
	
	delete f_time;
}

void quicksort(QVector<double>& d, QVector<int>& a)
{
	const int max_levels=300;
	double piv;
	int i, L, R, ol, swap;
	int b[max_levels];
	int e[max_levels];

	i=0;
	b[0]=0; e[0]=a.size();
	while(i>=0)
	{
		L=b[i]; R=e[i]-1;
		if(L<R)
		{
			piv=d[a[L]];
			ol=a[L];
			while(L<R)
			{
				while(d[a[R]]>=piv && L<R) R=R-1; 
				if(L<R)
				{
					a[L]=a[R];
					L=L+1;
				}
				while(d[a[L]]<=piv && L<R) L=L+1; 
				if(L<R)
				{
					a[R]=a[L]; 
					R=R-1;
				}
			}
			a[L]=ol; b[i+1]=L+1; e[i+1]=e[i]; e[i]=L; i=i+1;
			if(e[i]-b[i]>e[i-1]-b[i-1])
			{
				swap=b[i]; b[i]=b[i-1]; b[i-1]=swap;
				swap=e[i]; e[i]=e[i-1]; e[i-1]=swap; 
			}
		}
		else
			i=i-1; 
	}
}

void historywidget::fill_row(int row,int num,double res)
{
	set_table_item(table,row,0, res, prec);
	set_table_item(table,row,1, date_to_string(h[cur_level][num].day,
						h[cur_level][num].month,
						h[cur_level][num].year));
	set_table_item(table,row,2, hour_to_string(h[cur_level][num].hour,
						h[cur_level][num].minute,
						h[cur_level][num].second));
	for(int j=0;j<table_ctrs.size();++j)
	{
		Eval.refresh(&h[cur_level][num]);
		set_table_item(table,row,3+j, Eval.eval(table_ctrs[j]),table_prec[j]);
	}
}

void historywidget::show_toplists()
{
	tableLevel.setEnabled(true);
	tableCounter.setEnabled(true);
	tableRanges.setEnabled(false);

	table.clear();
		
	table.setColumnCount(3+table_ctrs.size());
	
	table.setHorizontalHeaderItem(0,new QTableWidgetItem(cur_ind));
	table.setHorizontalHeaderItem(1,new QTableWidgetItem("Date"));
	table.setHorizontalHeaderItem(2,new QTableWidgetItem("Hour"));
	for(int j=0;j<table_ctrs.size();++j)
	{
		table.setHorizontalHeaderItem(3+j,new QTableWidgetItem(table_headers[j]));
	}
	
	try
	{
		QVector<double> res;
		QVector<int> inds;
		int num_games=0;
		for(int i=0;i<h[cur_level].size();++i)
		{
			if(!t_satisfies_condition(i))
			{
				res << 0.0;
				continue;
			}
			Eval.refresh(&(h[cur_level][i]));
			res << Eval.eval(ind);
			inds << i;
			++num_games;
		}
		table.setRowCount(num_games);
		if(!num_games) return;
		quicksort(res,inds);
		
		if(cur_better_is_higher)
			for(int i=num_games-1;i>=0;--i)
			{
				fill_row(num_games-i-1,inds[i],res[inds[i]]);
			}
		else
			for(int i=0;i<num_games;++i)
			{
				fill_row(i,inds[i],res[inds[i]]);
			}
	}
	catch(exceval)
	{
		msg("Oh shit, it can not be, it can not be!");
	}
	table.resizeRowsToContents();
	table.resizeColumnsToContents();
}

void historywidget::show_evolution()
{
	tableLevel.setEnabled(true);
	tableCounter.setEnabled(true);
	tableRanges.setEnabled(false);

	table.clear();
		
	table.setColumnCount(3+table_ctrs.size());
	
	table.setHorizontalHeaderItem(0,new QTableWidgetItem(cur_ind));
	table.setHorizontalHeaderItem(1,new QTableWidgetItem("Date"));
	table.setHorizontalHeaderItem(2,new QTableWidgetItem("Hour"));
	for(int j=0;j<table_ctrs.size();++j)
	{
		table.setHorizontalHeaderItem(3+j,new QTableWidgetItem(table_headers[j]));
	}
	
	try
	{
		int num_games=0,i;
		double cur,res=-1;
		table.setRowCount(h[cur_level].size());
		for(i=0;i<h[cur_level].size();++i)
		{
			if(!t_satisfies_condition(i))	continue;
			Eval.refresh(&(h[cur_level][i]));
			res=Eval.eval(ind);
			fill_row(num_games++,i,res);
			break;
		}
		for(++i;i<h[cur_level].size();++i)
		{
			if(!t_satisfies_condition(i))	continue;
			Eval.refresh(&(h[cur_level][i]));
			cur=Eval.eval(ind);
			if((cur<=res && !cur_better_is_higher) ||
				(cur>=res && cur_better_is_higher))
				fill_row(num_games++,i,res=cur);
		}
		table.setRowCount(num_games);
	}
	catch(exceval)
	{
		msg("Oh shit, it can not be, it can not be!");
	}
	table.resizeRowsToContents();
	table.resizeColumnsToContents();
}

void historywidget::show_daily()
{
	tableLevel.setEnabled(true);
	tableCounter.setEnabled(false);
	tableRanges.setEnabled(false);

	table.clear();
		
	table.setColumnCount(3+4*table_ctrs.size());
	
	table.setHorizontalHeaderItem(0,new QTableWidgetItem("Total"));
	table.setHorizontalHeaderItem(1,new QTableWidgetItem("From"));
	table.setHorizontalHeaderItem(2,new QTableWidgetItem("Till"));
	for(int j=0;j<table_ctrs.size();++j)
	{
		table.setHorizontalHeaderItem(3+4*j,new QTableWidgetItem(""));
		table.setHorizontalHeaderItem(4+4*j,new QTableWidgetItem("Best"));
		table.setHorizontalHeaderItem(5+4*j,new QTableWidgetItem(table_headers[j]));
		table.setHorizontalHeaderItem(6+4*j,new QTableWidgetItem("Worst"));
	}
	
	try
	{
		int num_rows=0,i=0;
		QVector<double> best,worst,avg;
		int cur_y=0,cur_m=0,cur_d=0;
		
		table.setRowCount(h[cur_level].size());

		for(int j=0;j<table_ctrs.size();++j)
		{
			best << 0.0;
			worst << 0.0;
			avg << 0.0;
		}
		
		while(i<h[cur_level].size())
		{
			int num_games;
			int first=0,last=0;
			
			num_games=0;
			for(;i<h[cur_level].size();++i)
			{
				if(!t_satisfies_condition(i)) continue;
				Eval.refresh(&(h[cur_level][last=first=i]));
				for(int j=0;j<table_ctrs.size();++j)
					best[j]=worst[j]=avg[j]=Eval.eval(table_ctrs[j]);
				cur_y=h[cur_level][i].year;
				cur_m=h[cur_level][i].month;
				cur_d=h[cur_level][i].day;
				num_games=1;
				break;
			}
			if(num_games) 
				for(++i;i<h[cur_level].size();++i)
				{
					if(!t_satisfies_condition(i)) continue;
					if(cur_y!=h[cur_level][i].year || cur_m!=h[cur_level][i].month || 
						cur_d!=h[cur_level][i].day)
						break;
					Eval.refresh(&(h[cur_level][last=i]));
					for(int j=0;j<table_ctrs.size();++j)
					{
						double d=Eval.eval(table_ctrs[j]);
						if((d<best[j]) ^ better_is_higher[j]) best[j]=d;
						if((d>worst[j]) ^ better_is_higher[j]) worst[j]=d;
						avg[j]+=d;
					}
					++num_games;
				}
			if(!num_games) break;
			table.setVerticalHeaderItem(num_rows,new QTableWidgetItem(date_to_string(cur_d,cur_m,cur_y)));
			
			set_table_item(table,num_rows,0, num_games,0);
			set_table_item(table,num_rows,1, hour_to_string(h[cur_level][first].hour,
				h[cur_level][first].minute,
				h[cur_level][first].second));
			set_table_item(table,num_rows,2, hour_to_string(h[cur_level][last].hour,
				h[cur_level][last].minute,
				h[cur_level][last].second));
			for(int j=0;j<table_ctrs.size();++j)
			{
				set_table_item(table,num_rows,4+4*j, best[j],table_prec[j]);
				set_table_item(table,num_rows,5+4*j, avg[j]/num_games,table_avg_prec[j]);
				set_table_item(table,num_rows,6+4*j, worst[j],table_prec[j]);
			}
			++num_rows;
			
		}
		table.setRowCount(num_rows);
	}
	catch(exceval)
	{
		msg("Oh shit, it can not be, it can not be!");
	}
	table.resizeRowsToContents();
	table.resizeColumnsToContents();
}

void historywidget::show_details()
{
	tableLevel.setEnabled(true);
	tableCounter.setEnabled(true);
	tableRanges.setEnabled(true);

	table.clear();
		
	table.setColumnCount(1+4*table_ctrs.size());
	
	table.setHorizontalHeaderItem(0,new QTableWidgetItem("Total"));
	for(int j=0;j<table_ctrs.size();++j)
	{
		table.setHorizontalHeaderItem(1+4*j,new QTableWidgetItem(""));
		table.setHorizontalHeaderItem(2+4*j,new QTableWidgetItem("Best"));
		table.setHorizontalHeaderItem(3+4*j,new QTableWidgetItem(table_headers[j]));
		table.setHorizontalHeaderItem(4+4*j,new QTableWidgetItem("Worst"));
	}
	
	try
	{
		int num_rows=0,i;
		int beg_num=-1,end_num=-1;
		QVector<bool> sat;
		QVector<int> num;
		QVector<double> res;
		QMap<int,int> n_games;
		QMap<int,double*> best,worst,avg;
		
		for(int i=0;i<h[cur_level].size();++i)
		{
			double cur_ind;
			int cur_num;
			
			if(!t_satisfies_condition(i))
			{
				sat << false;
				res << 0.0;
				continue;
			}
			sat << true;
			Eval.refresh(&(h[cur_level][i]));
			res << (cur_ind=Eval.eval(ind));
			cur_num=(int)(cur_ind/a_step);
			if(round_up && (int)cur_ind!=cur_ind) ++cur_num;
			num << cur_num;
			++n_games[cur_num];
		}
		
		for(i=0;i<h[cur_level].size();++i)
			if(sat[i])
			{
				Eval.refresh(&(h[cur_level][i]));

				beg_num=end_num=num[i];
				best[num[i]]=new double[table_ctrs.size()];
				worst[num[i]]=new double[table_ctrs.size()];
				avg[num[i]]=new double[table_ctrs.size()];

				for(int j=0;j<table_ctrs.size();++j)
				{
					best[num[i]][j]=worst[num[i]][j]=avg[num[i]][j]=Eval.eval(table_ctrs[j]);
				}
				
				break;
			}
		for(++i;i<h[cur_level].size();++i)
			if(sat[i])
			{
				Eval.refresh(&(h[cur_level][i]));

				if(beg_num>num[i]) beg_num=num[i];
				if(end_num<num[i]) end_num=num[i];
				if(!best[num[i]])
				{
					best[num[i]]=new double[table_ctrs.size()];
					worst[num[i]]=new double[table_ctrs.size()];
					avg[num[i]]=new double[table_ctrs.size()];
					for(int j=0;j<table_ctrs.size();++j)
					{
						best[num[i]][j]=worst[num[i]][j]=avg[num[i]][j]=
							Eval.eval(table_ctrs[j]);
					}
				}
				else
					for(int j=0;j<table_ctrs.size();++j)
					{
						double res=Eval.eval(table_ctrs[j]);
						avg[num[i]][j]+=res;
						if((res<best[num[i]][j]) ^ better_is_higher[j]) best[num[i]][j]=res;
						else if((res>worst[num[i]][j]) ^ better_is_higher[j])
							worst[num[i]][j]=res;
					}

			}
		
		table.setRowCount(end_num-beg_num+1);
		for(int i=beg_num;i<=end_num;++i)
		{
			if(!n_games[i]) continue;
			
			if(round_up)
				table.setVerticalHeaderItem(num_rows,new QTableWidgetItem(QString::number(i)));	
			else
				table.setVerticalHeaderItem(num_rows,
					new QTableWidgetItem(QString::number(i*a_step,'f',2)));
			
			set_table_item(table,num_rows,0, n_games[i],0);
			for(int j=0;j<table_ctrs.size();++j)
			{
				set_table_item(table,num_rows,2+4*j, best[i][j],table_prec[j]);
				set_table_item(table,num_rows,3+4*j, avg[i][j]/n_games[i],table_avg_prec[j]);
				set_table_item(table,num_rows,4+4*j, worst[i][j],table_prec[j]);
			}
			++num_rows;
			
			delete[] best[i];
			delete[] worst[i];
			delete[] avg[i];
		}
		
		table.setRowCount(num_rows);
		if(!num_rows) return;
	}
	catch(exceval)
	{
		msg("Oh shit, it can not be, it can not be!");
	}
	table.resizeRowsToContents();
	table.resizeColumnsToContents();
}

void historywidget::refresh_table()
{
	if(cur_level==0)
		t_beg.setChecked(true);
	else if(cur_level==1)
		t_int.setChecked(true);
	else if(cur_level==2)
		t_exp.setChecked(true);
	if(records.isChecked())
		show_records();
	else if(toplists.isChecked())
		show_toplists();
	else if(evolution.isChecked())
		show_evolution();
	else if(daily.isChecked())
		show_daily();
	else if(details.isChecked())
		show_details();
}

void historywidget::fill_search_row(int row,int level,int num,int all)
{
	QString levels[]={"Beg","Int","Exp"};

	set_table_item(searchTable,row,0, date_to_string(h[level][num].day,
							h[level][num].month,
							h[level][num].year));
	set_table_item(searchTable,row,1, hour_to_string(h[level][num].hour,
							h[level][num].minute,
							h[level][num].second));
	if(all)
		set_table_item(searchTable,row,2,levels[level]);
		
	for(int j=0;j<table_ctrs.size();++j)
	{
		Eval.refresh(&h[level][num]);
		set_table_item(searchTable,row,2+j+all, Eval.eval(table_ctrs[j]),table_prec[j]);
	}
}

void historywidget::makesearch()
{
	formula* cond=Parser.parse_expression(searchLine.text());
	if(searchLine.text()=="") cond=Parser.parse_expression("1>0");
	if(!cond) return;

	int all=searchAll.isChecked();
	int levels[]={searchBeg.isChecked() || searchAll.isChecked(),
					searchInt.isChecked() || searchAll.isChecked(),
					searchExp.isChecked() || searchAll.isChecked()};
	
	searchTable.clear();
		
	searchTable.setColumnCount(2+all+table_ctrs.size());
	
	searchTable.setHorizontalHeaderItem(0,new QTableWidgetItem("Date"));
	searchTable.setHorizontalHeaderItem(1,new QTableWidgetItem("Hour"));
	if(all)
		searchTable.setHorizontalHeaderItem(2,new QTableWidgetItem("Level"));
	for(int j=0;j<table_ctrs.size();++j)
	{
		searchTable.setHorizontalHeaderItem(2+all+j,new QTableWidgetItem(table_headers[j]));
	}
	
	try
	{
		QVector<double> res;
		QVector<int> levs;
		QVector<int> inds;
		int num_games=0;
		for(int l=0;l<3;++l)
		{		
			if(!levels[l]) continue;
			for(int i=0;i<h[l].size();++i)
			{
				Eval.refresh(&(h[l][i]));
				if(!Eval.eval_expr(cond)) continue;
				levs << l;
				inds << i;
				++num_games;
			}
		}
		searchTable.setRowCount(num_games);
		if(!num_games) return;
		
		for(int i=0;i<num_games;++i)
		{
			fill_search_row(i,levs[i],inds[i],all);
		}
	}
	catch(exceval)
	{
		msg("Oh shit, it can not be, it can not be!");
	}

	searchTable.resizeRowsToContents();
	searchTable.resizeColumnsToContents();
	
	delete cond;
}

