#include "settings.h"

settings::settings(const QString& filename)
{
	store.setFileName(filename);
}

bool settings::read()
{
	QString line,name,value;
	if(store.open(QIODevice::ReadOnly))
	{
		while(!store.atEnd())
		{
			int sp;
			line=QString::fromUtf8(store.readLine());
			// if it's not a valid entry ("Name = Value"), ignore
			if( (sp=line.indexOf('=')) == -1) continue;	
			name=line.left(sp).trimmed();
			value=line.mid(sp+1).trimmed();
			data[name]=value;
		}
		store.close();
		return true;
	}
	else
	{
		return false;
	}
}

QString settings::get(const QString& name)
{
	return data[name];
}

int settings::getint(const QString& name)
{
	return data[name].toInt();
}

double settings::getdouble(const QString& name)
{
	return data[name].toDouble();
}

void settings::set(const QString& name,const QString& value)
{
	data[name]=value;
}
void settings::set(const QString& name,int value)
{
	data[name]=QString::number(value);
}
void settings::set(const QString& name,double value)
{
	data[name]=QString::number(value);
}

bool settings::write()
{
	if(store.open(QIODevice::WriteOnly | QIODevice::Truncate))
	{
		for(QMap<QString,QString>::iterator i=data.begin();i!=data.end();++i)
		{
			store.write((i.key() + " = " + i.value() + "\n").toUtf8());
		}
		store.close();
		return true;
	}
	else
	{
		return false;
	}
}

